#<profile4xi profile = "31"/>
#<program4xi program = "automate2ref4uri.py">
#<abstract4xi abstract = "creates target functions for 33 processes to check local URI references in HTML-files"/>
#<refer4xi reference = "automate2analyse4xi.py"/>
#<note4xi note = "output is automatically deleted and written again by opening to write"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
#<use4xi usage = "
#
# 1) go to Studio4Xi in commmand mode
#     > go3studio4fb    <-- Python 3 version of Studio4Xi in Fastblack workstation (fb)
#     > go3studio4riika <-- Python 3 version of Studio4Xi in Riika
#     nb: you could use the same go2studio4xi-command in all workstations just defining root! 
#
# 2) edit version4xi.py
#
#      # ===========================================================================================================                         
#      # automate2ref4uri.py
#      # ===========================================================================================================                          
#      'master2ref4uri':   'J://temp//yosense//test2master//',         # [ACK] Sun       (master used by automate2ref4uri.py only) 
#      'dragon2ref4uri':   'F://temp//yosense//test2dragon//',         # [ACK] Saturn    (base for 1 ... 33)
#      
#      #dynamic-start
#      'zero2ref4uri':     'D://temp//yosense//test2zero//',           # [ACK] Eris      
#      'one2ref4uri':      'G://temp//yosense//test2one//',            # [ACK] Titan     
#      'two2ref4uri':      'H://temp//yosense//test2two//',            # [ACK] Enceladus 
#      'three2ref4uri':    'I://temp//yosense//test2three//',          # [ACK] Phoebe    
#      'four2ref4uri':     'K://temp//yosense//test2four//',           # [ACK] Theia     
#      'five2ref4uri':     'L://temp//yosense//test2five//',           # [ACK] Haumea    
#      'six2ref4uri':      'M://temp//yosense//test2six//',            # [ACK] Logic     
#      'seven2ref4uri':    'N://temp//yosense//test2seven//',          # [ACK] Venus     
#      'eight2ref4uri':    'O://temp//yosense//test2eight//',          # [ACK] Jupiter  
#      'nine2ref4uri':     'P://temp//yosense//test2nine//',           # [ACK] Kelvin   
#      'ten2ref4uri':      'Q://temp//yosense//test2ten//',            # [ACK] Taiko   
#      'eleven2ref4uri':   'F://temp//yosense//test2eleven//',         # [ACK] Saturn   
#      'twelve2ref4uri':   'G://temp//yosense//test2twelve//',         # [ACK] Titan    
#      'thirteen2ref4uri': 'M://temp//yosense//test2thirteen//',       # [ACK] Logic   
#      'fourteen2ref4uri': 'K://temp//yosense//test2fourteen//',       # [ACK] Theia   
#      'fifteen2ref4uri':  'L://temp//yosense//test2fifteen//',        # [ACK] Haumea  
#      'sixteen2ref4uri':  'M://temp//yosense//test2sixteen//',        # [ACK] Logic   
#      'seventeen2ref4uri':'N://temp//yosense//test2seventeen//',      # [ACK] Venus   
#      'eighteen2ref4uri': 'O://temp//yosense//test2eighteen//',       # [ACK] Jupiter 
#      'nineteen2ref4uri': 'P://temp//yosense//test2nineteen//',       # [ACK] Kelvin  
#      
#      'twenty2ref4uri':      'Q://temp//yosense//test2twenty//',      # [ACK] Taiko   
#      'twentyone2ref4uri':   'F://temp//yosense//test2twentyone//',   # [ACK] Saturn  
#      'twentytwo2ref4uri':   'G://temp//yosense//test2twentytwo//',   # [ACK] Titan   
#      'twentythree2ref4uri': 'I://temp//yosense//test2twentythree//', # [ACK] Phoebe  
#      'twentyfour2ref4uri':  'K://temp//yosense//test2twentyfour//',  # [ACK] Theia   
#      'twentyfive2ref4uri':  'L://temp//yosense//test2twentyfive//',  # [ACK] Haumea 
#      'twentysix2ref4uri':   'M://temp//yosense//test2twentysix//',   # [ACK] Logic  
#      'twentyseven2ref4uri': 'N://temp//yosense//test2twentyseven//', # [ACK] Venus  
#      'twentyeight2ref4uri': 'O://temp//yosense//test2twentyeight//', # [ACK] Jupiter
#      'twentynine2ref4uri':  'P://temp//yosense//test2twentynine//',  # [ACK] Kelvin  
#      
#      'thirty2ref4uri':      'Q://temp//yosense//test2thirty//',      # [ACK] Taiko  
#      'thirtyone2ref4uri':   'F://temp//yosense//test2thirtyone//',   # [ACK] Saturn 
#      'thirtytwo2ref4uri':   'G://temp//yosense//test2thirtytwo//',   # [ACK] Titan  
#      'thirtythree2ref4uri': 'M://temp//yosense//test2thirtythree//', # [ACK] Logic  
#      #dynamic-end
#                                               
# 3) modify behaviour (if necessary):
#    a) ack2index = True (default)           <-- True,  if you want to create index.html files
#
# 4) > automate2ref4uri
#
# 5) view trace
#      \temp\automate2ref4uri.txt <-- check for any erros, if necessary and see statistics
#      \web\xmlace-automate2ref4uri.xml
#      \web\reason-automate2ref4uri.xml
#      \web\sense-automate2ref4uri.xml
#      
# 6) test hyperlinks
# 
# 7) test hyperlinks locally and correct & rerun, if necessary
#    file:///E:/DRAGONXI/PC4Xi/YoDragonXiOrg/WebSite/sense/index-sense-xi2.html
#
# 8) copy and ftp upload to server corrected HTML files
#    E:\DRAGONXI\PC4Xi\YoDragonXiOrg\WebSite\sense
#
# 9) test with browser web content (password protected)
#    https://www.yourdragonxi.org/sense/index-sense-xi2.html
#
# TIPS:
#    None
#"
#/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'automate2ref4uri.py' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                           
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string

import threading                
import _thread
import _winapi 

import signal
import itertools
import weakref
import logging 

#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi 
from version4xi import ROOT4XI
#dynamic-start
from generate2gun4uri import generate2gun4uri
from generate2shoot4uri import generate2shoot4uri
#dynamic-end
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi

# -------------------------------
# dragon
# -------------------------------
from gun2dragon4uri import gun2dragon4uri

#dynamic-start
# import can be done only after the function has been generated
#dynamic-end

from current_process4xi import get_current_process4xi            
from current_process4xi import get_identity_current_process4xi
from current_process4xi import get_name_current_process4xi

from dummyprocess4xi import DummyProcess4Xi

from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import Print4Xi 


from print4xi import print4xi
from print4xi import set_print_permission4xi
from process4xi import Process4Xi

from queue4xi import Queue4Xi

from sleep4xi import omega2sleep4xi

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2message4index

global ack4queues
global nack4queues

global ack4pipes
global nack4pipes

global ack4process
global nack4process

global ack4start
global nack4start   
        
global ack4run
global nack4run

#dynamic-start
global DirectionKB4Xi
global keys2DirectionKB4Xi
global key2DirectionKB4Xi
#dynamic-end

global DomainKB4Xi
global keys2DomainKB4Xi
global key2DomainKB4Xi

global master2ref4uri 
global dragon2ref4uri

#dynamic-start 
global zero2ref4uri                          
global one2ref4uri
global two2ref4uri
global three2ref4uri
global four2ref4uri
global five2ref4uri
global six2ref4uri
global seven2ref4uri
global eight2ref4uri
global nine2ref4uri
global ten2ref4uri
global eleven2ref4uri
global twelve2ref4uri
global thirteen2ref4uri
global fourteen2ref4uri
global fifteen2ref4uri
global sixteen2ref4uri
global seventeen2ref4uri
global eighteen2ref4uri
global nineteen2ref4uri
global twenty2ref4uri
global twentyone2ref4uri
global twentytwo2ref4uri
global twentythree2ref4uri
global twentyfour2ref4uri
global twentyfive2ref4uri
global twentysix2ref4uri
global twentyseven2ref4uri
global twentyeight2ref4uri
global twentynine2ref4uri
global thirty2ref4uri
global thirtyone2ref4uri
global thirtytwo2ref4uri
global thirtythree2ref4uri
#dynamic-end

global path2temp4xi                          # path for output files
global PickleKB4Xi

global NameKB4Xi
global keys2NameKB4Xi
global key2NameKB4Xi

global MonthKB4Xi
global keys2MonthKB4Xi
global key2MonthKB4Xi

global t2xi 
global trace_object_count 
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings 
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2message4index = False
AlphaKB4Xi      = {}
AlphaKB4Xi['a'] = {}
AlphaKB4Xi['b'] = {}
AlphaKB4Xi['c'] = {}
AlphaKB4Xi['d'] = {}
AlphaKB4Xi['e'] = {}
AlphaKB4Xi['f'] = {}
AlphaKB4Xi['g'] = {}
AlphaKB4Xi['h'] = {}
AlphaKB4Xi['i'] = {}
AlphaKB4Xi['j'] = {}
AlphaKB4Xi['k'] = {}
AlphaKB4Xi['l'] = {}
AlphaKB4Xi['m'] = {}
AlphaKB4Xi['n'] = {}
AlphaKB4Xi['o'] = {}
AlphaKB4Xi['p'] = {}
AlphaKB4Xi['q'] = {}
AlphaKB4Xi['r'] = {}
AlphaKB4Xi['s'] = {}
AlphaKB4Xi['t'] = {}
AlphaKB4Xi['u'] = {}
AlphaKB4Xi['v'] = {}
AlphaKB4Xi['w'] = {}
AlphaKB4Xi['x'] = {}
AlphaKB4Xi['y'] = {}
AlphaKB4Xi['z'] = {} 
keys2AlphaKB4Xi = AlphaKB4Xi.keys()
key2AlphaKB4Xi  = 0

IndexKB4Xi = {}
IndexKB4Xi[0] = {}
IndexKB4Xi[1] = {}
IndexKB4Xi[2] = {}
IndexKB4Xi[3] = {}
IndexKB4Xi[4] = {}
IndexKB4Xi[5] = {}
IndexKB4Xi[6] = {}
IndexKB4Xi[7] = {}
IndexKB4Xi[8] = {}
keys2IndexKB4Xi = IndexKB4Xi.keys()
key2IndexKB4Xi  = 0        

LevelOneKB4Xi = {}
keys2LevelOneKB4Xi = LevelOneKB4Xi.keys()
key2LevelOneKB4Xi  = 0

LevelTwoKB4Xi = {}
keys2LevelTwoKB4Xi = LevelTwoKB4Xi.keys()
key2LevelTwoKB4Xi  = 0

CountTwoKB4Xi = {}
keys2CountTwoKB4Xi = CountTwoKB4Xi.keys()
key2CountTwoKB4Xi  = 0

#dynamic-start
 
DirectionKB4Xi = {}

DirectionKB4Xi['zero']     = {}
DirectionKB4Xi['zero'] ['channel2publish']  = None
DirectionKB4Xi['zero'] ['channel2consume']  = None
DirectionKB4Xi['zero'] ['queue'] = None
DirectionKB4Xi['zero'] ['function2target']  = None
DirectionKB4Xi['zero'] ['number2process']   = None
DirectionKB4Xi['zero'] ['name2process']     = None
DirectionKB4Xi['zero'] ['status2process']   = None
DirectionKB4Xi['zero'] ['cc2put']           = "<copy4xi>copy2zero</copy4xi>"
DirectionKB4Xi['zero'] ['cc2send']          = "<copy4xi>copy2zero</copy4xi>"
DirectionKB4Xi['zero'] ['cc2get']           = "<roger4xi>roger2zero</roger4xi>"
DirectionKB4Xi['zero'] ['cc2receive']       = "<roger4xi>roger2zero</roger4xi>"
DirectionKB4Xi['zero'] ['path2analyse']     = VersionKB4Xi['zero2ref4uri']

DirectionKB4Xi['one']     = {}
DirectionKB4Xi['one'] ['channel2publish']  = None
DirectionKB4Xi['one'] ['channel2consume']  = None
DirectionKB4Xi['one'] ['queue'] = None
DirectionKB4Xi['one'] ['function2target']  = None
DirectionKB4Xi['one'] ['number2process']   = None
DirectionKB4Xi['one'] ['name2process']     = None
DirectionKB4Xi['one'] ['status2process']   = None
DirectionKB4Xi['one'] ['cc2put']           = "<copy4xi>copy2one</copy4xi>"
DirectionKB4Xi['one'] ['cc2send']          = "<copy4xi>copy2one</copy4xi>"
DirectionKB4Xi['one'] ['cc2get']           = "<roger4xi>roger2one</roger4xi>"
DirectionKB4Xi['one'] ['cc2receive']       = "<roger4xi>roger2one</roger4xi>"
DirectionKB4Xi['one'] ['path2analyse']     = VersionKB4Xi['one2ref4uri']

DirectionKB4Xi['two']     = {}
DirectionKB4Xi['two'] ['channel2publish']  = None
DirectionKB4Xi['two'] ['channel2consume']  = None
DirectionKB4Xi['two'] ['queue'] = None
DirectionKB4Xi['two'] ['function2target']  = None
DirectionKB4Xi['two'] ['number2process']   = None
DirectionKB4Xi['two'] ['name2process']     = None
DirectionKB4Xi['two'] ['status2process']   = None
DirectionKB4Xi['two'] ['cc2put']           = "<copy4xi>copy2two</copy4xi>"
DirectionKB4Xi['two'] ['cc2send']          = "<copy4xi>copy2two</copy4xi>"
DirectionKB4Xi['two'] ['cc2get']           = "<roger4xi>roger2two</roger4xi>"
DirectionKB4Xi['two'] ['cc2receive']       = "<roger4xi>roger2two</roger4xi>"
DirectionKB4Xi['two'] ['path2analyse']     = VersionKB4Xi['two2ref4uri']

DirectionKB4Xi['three']     = {}
DirectionKB4Xi['three'] ['channel2publish']  = None
DirectionKB4Xi['three'] ['channel2consume']  = None
DirectionKB4Xi['three'] ['queue'] = None
DirectionKB4Xi['three'] ['function2target']  = None
DirectionKB4Xi['three'] ['number2process']   = None
DirectionKB4Xi['three'] ['name2process']     = None
DirectionKB4Xi['three'] ['status2process']   = None
DirectionKB4Xi['three'] ['cc2put']           = "<copy4xi>copy2three</copy4xi>"
DirectionKB4Xi['three'] ['cc2send']          = "<copy4xi>copy2three</copy4xi>"
DirectionKB4Xi['three'] ['cc2get']           = "<roger4xi>roger2three</roger4xi>"
DirectionKB4Xi['three'] ['cc2receive']       = "<roger4xi>roger2three</roger4xi>"
DirectionKB4Xi['three'] ['path2analyse']     = VersionKB4Xi['three2ref4uri']

DirectionKB4Xi['four']     = {}
DirectionKB4Xi['four'] ['channel2publish']  = None
DirectionKB4Xi['four'] ['channel2consume']  = None
DirectionKB4Xi['four'] ['queue'] = None
DirectionKB4Xi['four'] ['function2target']  = None
DirectionKB4Xi['four'] ['number2process']   = None
DirectionKB4Xi['four'] ['name2process']     = None
DirectionKB4Xi['four'] ['status2process']   = None
DirectionKB4Xi['four'] ['cc2put']           = "<copy4xi>copy2four</copy4xi>"
DirectionKB4Xi['four'] ['cc2send']          = "<copy4xi>copy2four</copy4xi>"
DirectionKB4Xi['four'] ['cc2get']           = "<roger4xi>roger2four</roger4xi>"
DirectionKB4Xi['four'] ['cc2receive']       = "<roger4xi>roger2four</roger4xi>"
DirectionKB4Xi['four'] ['path2analyse']     = VersionKB4Xi['four2ref4uri']

DirectionKB4Xi['five']     = {}
DirectionKB4Xi['five'] ['channel2publish']  = None
DirectionKB4Xi['five'] ['channel2consume']  = None
DirectionKB4Xi['five'] ['queue'] = None
DirectionKB4Xi['five'] ['function2target']  = None
DirectionKB4Xi['five'] ['number2process']   = None
DirectionKB4Xi['five'] ['name2process']     = None
DirectionKB4Xi['five'] ['status2process']   = None
DirectionKB4Xi['five'] ['cc2put']           = "<copy4xi>copy2five</copy4xi>"
DirectionKB4Xi['five'] ['cc2send']          = "<copy4xi>copy2five</copy4xi>"
DirectionKB4Xi['five'] ['cc2get']           = "<roger4xi>roger2five</roger4xi>"
DirectionKB4Xi['five'] ['cc2receive']       = "<roger4xi>roger2five</roger4xi>"
DirectionKB4Xi['five'] ['path2analyse']     = VersionKB4Xi['five2ref4uri']

DirectionKB4Xi['six']     = {}
DirectionKB4Xi['six'] ['channel2publish']  = None
DirectionKB4Xi['six'] ['channel2consume']  = None
DirectionKB4Xi['six'] ['queue'] = None
DirectionKB4Xi['six'] ['function2target']  = None
DirectionKB4Xi['six'] ['number2process']   = None
DirectionKB4Xi['six'] ['name2process']     = None
DirectionKB4Xi['six'] ['status2process']   = None
DirectionKB4Xi['six'] ['cc2put']           = "<copy4xi>copy2six</copy4xi>"
DirectionKB4Xi['six'] ['cc2send']          = "<copy4xi>copy2six</copy4xi>"
DirectionKB4Xi['six'] ['cc2get']           = "<roger4xi>roger2six</roger4xi>"
DirectionKB4Xi['six'] ['cc2receive']       = "<roger4xi>roger2six</roger4xi>"
DirectionKB4Xi['six'] ['path2analyse']     = VersionKB4Xi['six2ref4uri']

DirectionKB4Xi['seven']     = {}
DirectionKB4Xi['seven'] ['channel2publish']  = None
DirectionKB4Xi['seven'] ['channel2consume']  = None
DirectionKB4Xi['seven'] ['queue'] = None
DirectionKB4Xi['seven'] ['function2target']  = None
DirectionKB4Xi['seven'] ['number2process']   = None
DirectionKB4Xi['seven'] ['name2process']     = None
DirectionKB4Xi['seven'] ['status2process']   = None
DirectionKB4Xi['seven'] ['cc2put']           = "<copy4xi>copy2seven</copy4xi>"
DirectionKB4Xi['seven'] ['cc2send']          = "<copy4xi>copy2seven</copy4xi>"
DirectionKB4Xi['seven'] ['cc2get']           = "<roger4xi>roger2seven</roger4xi>"
DirectionKB4Xi['seven'] ['cc2receive']       = "<roger4xi>roger2seven</roger4xi>"
DirectionKB4Xi['seven'] ['path2analyse']     = VersionKB4Xi['seven2ref4uri']

DirectionKB4Xi['eight']     = {}
DirectionKB4Xi['eight'] ['channel2publish']  = None
DirectionKB4Xi['eight'] ['channel2consume']  = None
DirectionKB4Xi['eight'] ['queue'] = None
DirectionKB4Xi['eight'] ['function2target']  = None
DirectionKB4Xi['eight'] ['number2process']   = None
DirectionKB4Xi['eight'] ['name2process']     = None
DirectionKB4Xi['eight'] ['status2process']   = None
DirectionKB4Xi['eight'] ['cc2put']           = "<copy4xi>copy2eight</copy4xi>"
DirectionKB4Xi['eight'] ['cc2send']          = "<copy4xi>copy2eight</copy4xi>"
DirectionKB4Xi['eight'] ['cc2get']           = "<roger4xi>roger2eight</roger4xi>"
DirectionKB4Xi['eight'] ['cc2receive']       = "<roger4xi>roger2eight</roger4xi>"
DirectionKB4Xi['eight'] ['path2analyse']     = VersionKB4Xi['eight2ref4uri']

DirectionKB4Xi['nine']     = {}
DirectionKB4Xi['nine'] ['channel2publish']  = None
DirectionKB4Xi['nine'] ['channel2consume']  = None
DirectionKB4Xi['nine'] ['queue'] = None
DirectionKB4Xi['nine'] ['function2target']  = None
DirectionKB4Xi['nine'] ['number2process']   = None
DirectionKB4Xi['nine'] ['name2process']     = None
DirectionKB4Xi['nine'] ['status2process']   = None
DirectionKB4Xi['nine'] ['cc2put']           = "<copy4xi>copy2nine</copy4xi>"
DirectionKB4Xi['nine'] ['cc2send']          = "<copy4xi>copy2nine</copy4xi>"
DirectionKB4Xi['nine'] ['cc2get']           = "<roger4xi>roger2nine</roger4xi>"
DirectionKB4Xi['nine'] ['cc2receive']       = "<roger4xi>roger2nine</roger4xi>"
DirectionKB4Xi['nine'] ['path2analyse']     = VersionKB4Xi['nine2ref4uri']

DirectionKB4Xi['ten']     = {}
DirectionKB4Xi['ten'] ['channel2publish']  = None
DirectionKB4Xi['ten'] ['channel2consume']  = None
DirectionKB4Xi['ten'] ['queue'] = None
DirectionKB4Xi['ten'] ['function2target']  = None
DirectionKB4Xi['ten'] ['number2process']   = None
DirectionKB4Xi['ten'] ['name2process']     = None
DirectionKB4Xi['ten'] ['status2process']   = None
DirectionKB4Xi['ten'] ['cc2put']           = "<copy4xi>copy2ten</copy4xi>"
DirectionKB4Xi['ten'] ['cc2send']          = "<copy4xi>copy2ten</copy4xi>"
DirectionKB4Xi['ten'] ['cc2get']           = "<roger4xi>roger2ten</roger4xi>"
DirectionKB4Xi['ten'] ['cc2receive']       = "<roger4xi>roger2ten</roger4xi>"
DirectionKB4Xi['ten'] ['path2analyse']     = VersionKB4Xi['ten2ref4uri']

DirectionKB4Xi['eleven']     = {}
DirectionKB4Xi['eleven'] ['channel2publish']  = None
DirectionKB4Xi['eleven'] ['channel2consume']  = None
DirectionKB4Xi['eleven'] ['queue'] = None
DirectionKB4Xi['eleven'] ['function2target']  = None
DirectionKB4Xi['eleven'] ['number2process']   = None
DirectionKB4Xi['eleven'] ['name2process']     = None
DirectionKB4Xi['eleven'] ['status2process']   = None
DirectionKB4Xi['eleven'] ['cc2put']           = "<copy4xi>copy2eleven</copy4xi>"
DirectionKB4Xi['eleven'] ['cc2send']          = "<copy4xi>copy2eleven</copy4xi>"
DirectionKB4Xi['eleven'] ['cc2get']           = "<roger4xi>roger2eleven</roger4xi>"
DirectionKB4Xi['eleven'] ['cc2receive']       = "<roger4xi>roger2eleven</roger4xi>"
DirectionKB4Xi['eleven'] ['path2analyse']     = VersionKB4Xi['eleven2ref4uri']

DirectionKB4Xi['twelve']     = {}
DirectionKB4Xi['twelve'] ['channel2publish']  = None
DirectionKB4Xi['twelve'] ['channel2consume']  = None
DirectionKB4Xi['twelve'] ['queue'] = None
DirectionKB4Xi['twelve'] ['function2target']  = None
DirectionKB4Xi['twelve'] ['number2process']   = None
DirectionKB4Xi['twelve'] ['name2process']     = None
DirectionKB4Xi['twelve'] ['status2process']   = None
DirectionKB4Xi['twelve'] ['cc2put']           = "<copy4xi>copy2twelve</copy4xi>"
DirectionKB4Xi['twelve'] ['cc2send']          = "<copy4xi>copy2twelve</copy4xi>"
DirectionKB4Xi['twelve'] ['cc2get']           = "<roger4xi>roger2twelve</roger4xi>"
DirectionKB4Xi['twelve'] ['cc2receive']       = "<roger4xi>roger2twelve</roger4xi>"
DirectionKB4Xi['twelve'] ['path2analyse']     = VersionKB4Xi['twelve2ref4uri']

DirectionKB4Xi['thirteen']     = {}
DirectionKB4Xi['thirteen'] ['channel2publish']  = None
DirectionKB4Xi['thirteen'] ['channel2consume']  = None
DirectionKB4Xi['thirteen'] ['queue'] = None
DirectionKB4Xi['thirteen'] ['function2target']  = None
DirectionKB4Xi['thirteen'] ['number2process']   = None
DirectionKB4Xi['thirteen'] ['name2process']     = None
DirectionKB4Xi['thirteen'] ['status2process']   = None
DirectionKB4Xi['thirteen'] ['cc2put']           = "<copy4xi>copy2thirteen</copy4xi>"
DirectionKB4Xi['thirteen'] ['cc2send']          = "<copy4xi>copy2thirteen</copy4xi>"
DirectionKB4Xi['thirteen'] ['cc2get']           = "<roger4xi>roger2thirteen</roger4xi>"
DirectionKB4Xi['thirteen'] ['cc2receive']       = "<roger4xi>roger2thirteen</roger4xi>"
DirectionKB4Xi['thirteen'] ['path2analyse']     = VersionKB4Xi['thirteen2ref4uri']

DirectionKB4Xi['fourteen']     = {}
DirectionKB4Xi['fourteen'] ['channel2publish']  = None
DirectionKB4Xi['fourteen'] ['channel2consume']  = None
DirectionKB4Xi['fourteen'] ['queue'] = None
DirectionKB4Xi['fourteen'] ['function2target']  = None
DirectionKB4Xi['fourteen'] ['number2process']   = None
DirectionKB4Xi['fourteen'] ['name2process']     = None
DirectionKB4Xi['fourteen'] ['status2process']   = None
DirectionKB4Xi['fourteen'] ['cc2put']           = "<copy4xi>copy2fourteen</copy4xi>"
DirectionKB4Xi['fourteen'] ['cc2send']          = "<copy4xi>copy2fourteen</copy4xi>"
DirectionKB4Xi['fourteen'] ['cc2get']           = "<roger4xi>roger2fourteen</roger4xi>"
DirectionKB4Xi['fourteen'] ['cc2receive']       = "<roger4xi>roger2fourteen</roger4xi>"
DirectionKB4Xi['fourteen'] ['path2analyse']     = VersionKB4Xi['fourteen2ref4uri']

DirectionKB4Xi['fifteen']      = {}
DirectionKB4Xi['fifteen'] ['channel2publish']  = None
DirectionKB4Xi['fifteen'] ['channel2consume']  = None
DirectionKB4Xi['fifteen'] ['queue'] = None
DirectionKB4Xi['fifteen'] ['function2target']  = None
DirectionKB4Xi['fifteen'] ['number2process']   = None
DirectionKB4Xi['fifteen'] ['name2process']     = None
DirectionKB4Xi['fifteen'] ['status2process']   = None
DirectionKB4Xi['fifteen'] ['cc2put']           = "<copy4xi>copy2fifteen</copy4xi>"
DirectionKB4Xi['fifteen'] ['cc2send']          = "<copy4xi>copy2fifteen</copy4xi>"
DirectionKB4Xi['fifteen'] ['cc2get']           = "<roger4xi>roger2fifteen</roger4xi>"
DirectionKB4Xi['fifteen'] ['cc2receive']       = "<roger4xi>roger2fifteen</roger4xi>"
DirectionKB4Xi['fifteen'] ['path2analyse']     = VersionKB4Xi['fifteen2ref4uri']

DirectionKB4Xi['sixteen']      = {}
DirectionKB4Xi['sixteen'] ['channel2publish']  = None
DirectionKB4Xi['sixteen'] ['channel2consume']  = None
DirectionKB4Xi['sixteen'] ['queue'] = None
DirectionKB4Xi['sixteen'] ['function2target']  = None
DirectionKB4Xi['sixteen'] ['number2process']   = None
DirectionKB4Xi['sixteen'] ['name2process']     = None
DirectionKB4Xi['sixteen'] ['status2process']   = None
DirectionKB4Xi['sixteen'] ['cc2put']           = "<copy4xi>copy2sixteen</copy4xi>"
DirectionKB4Xi['sixteen'] ['cc2send']          = "<copy4xi>copy2sixteen</copy4xi>"
DirectionKB4Xi['sixteen'] ['cc2get']           = "<roger4xi>roger2sixteen</roger4xi>"
DirectionKB4Xi['sixteen'] ['cc2receive']       = "<roger4xi>roger2sixteen</roger4xi>"
DirectionKB4Xi['sixteen'] ['path2analyse']     = VersionKB4Xi['sixteen2ref4uri']

DirectionKB4Xi['seventeen']    = {}
DirectionKB4Xi['seventeen'] ['channel2publish']  = None
DirectionKB4Xi['seventeen'] ['channel2consume']  = None
DirectionKB4Xi['seventeen'] ['queue'] = None
DirectionKB4Xi['seventeen'] ['function2target']  = None
DirectionKB4Xi['seventeen'] ['number2process']   = None
DirectionKB4Xi['seventeen'] ['name2process']     = None
DirectionKB4Xi['seventeen'] ['status2process']   = None
DirectionKB4Xi['seventeen'] ['cc2put']           = "<copy4xi>copy2seventeen</copy4xi>"
DirectionKB4Xi['seventeen'] ['cc2send']          = "<copy4xi>copy2seventeen</copy4xi>"
DirectionKB4Xi['seventeen'] ['cc2get']           = "<roger4xi>roger2seventeen</roger4xi>"
DirectionKB4Xi['seventeen'] ['cc2receive']       = "<roger4xi>roger2seventeen</roger4xi>"
DirectionKB4Xi['seventeen'] ['path2analyse']     = VersionKB4Xi['seventeen2ref4uri']

DirectionKB4Xi['eighteen']     = {}
DirectionKB4Xi['eighteen'] ['channel2publish']  = None
DirectionKB4Xi['eighteen'] ['channel2consume']  = None
DirectionKB4Xi['eighteen'] ['queue'] = None
DirectionKB4Xi['eighteen'] ['function2target']  = None
DirectionKB4Xi['eighteen'] ['number2process']   = None
DirectionKB4Xi['eighteen'] ['name2process']     = None
DirectionKB4Xi['eighteen'] ['status2process']   = None
DirectionKB4Xi['eighteen'] ['cc2put']           = "<copy4xi>copy2eighteen</copy4xi>"
DirectionKB4Xi['eighteen'] ['cc2send']          = "<copy4xi>copy2eighteen</copy4xi>"
DirectionKB4Xi['eighteen'] ['cc2get']           = "<roger4xi>roger2eighteen</roger4xi>"
DirectionKB4Xi['eighteen'] ['cc2receive']       = "<roger4xi>roger2eighteen</roger4xi>"
DirectionKB4Xi['eighteen'] ['path2analyse']     = VersionKB4Xi['eighteen2ref4uri']

DirectionKB4Xi['nineteen']     = {}
DirectionKB4Xi['nineteen'] ['channel2publish']  = None
DirectionKB4Xi['nineteen'] ['channel2consume']  = None
DirectionKB4Xi['nineteen'] ['queue'] = None
DirectionKB4Xi['nineteen'] ['function2target']  = None
DirectionKB4Xi['nineteen'] ['number2process']   = None
DirectionKB4Xi['nineteen'] ['name2process']     = None
DirectionKB4Xi['nineteen'] ['status2process']   = None
DirectionKB4Xi['nineteen'] ['cc2put']           = "<copy4xi>copy2nineteen</copy4xi>"
DirectionKB4Xi['nineteen'] ['cc2send']          = "<copy4xi>copy2nineteen</copy4xi>"
DirectionKB4Xi['nineteen'] ['cc2get']           = "<roger4xi>roger2nineteen</roger4xi>"
DirectionKB4Xi['nineteen'] ['cc2receive']       = "<roger4xi>roger2nineteen</roger4xi>"
DirectionKB4Xi['nineteen'] ['path2analyse']     = VersionKB4Xi['nineteen2ref4uri']

DirectionKB4Xi['twenty']       = {}
DirectionKB4Xi['twenty'] ['channel2publish']  = None
DirectionKB4Xi['twenty'] ['channel2consume']  = None
DirectionKB4Xi['twenty'] ['queue'] = None
DirectionKB4Xi['twenty'] ['function2target']  = None
DirectionKB4Xi['twenty'] ['number2process']   = None
DirectionKB4Xi['twenty'] ['name2process']     = None
DirectionKB4Xi['twenty'] ['status2process']   = None
DirectionKB4Xi['twenty'] ['cc2put']           = "<copy4xi>copy2twenty</copy4xi>"
DirectionKB4Xi['twenty'] ['cc2send']          = "<copy4xi>copy2twenty</copy4xi>"
DirectionKB4Xi['twenty'] ['cc2get']           = "<roger4xi>roger2twenty</roger4xi>"
DirectionKB4Xi['twenty'] ['cc2receive']       = "<roger4xi>roger2twenty</roger4xi>"
DirectionKB4Xi['twenty'] ['path2analyse']     = VersionKB4Xi['twenty2ref4uri']

DirectionKB4Xi['twentyone']    = {}
DirectionKB4Xi['twentyone'] ['channel2publish']  = None
DirectionKB4Xi['twentyone'] ['channel2consume']  = None
DirectionKB4Xi['twentyone'] ['queue'] = None
DirectionKB4Xi['twentyone'] ['function2target']  = None
DirectionKB4Xi['twentyone'] ['number2process']   = None
DirectionKB4Xi['twentyone'] ['name2process']     = None
DirectionKB4Xi['twentyone'] ['status2process']   = None
DirectionKB4Xi['twentyone'] ['cc2put']           = "<copy4xi>copy2twentyone</copy4xi>"
DirectionKB4Xi['twentyone'] ['cc2send']          = "<copy4xi>copy2twentyone</copy4xi>"
DirectionKB4Xi['twentyone'] ['cc2get']           = "<roger4xi>roger2twentyone</roger4xi>"
DirectionKB4Xi['twentyone'] ['cc2receive']       = "<roger4xi>roger2twentyone</roger4xi>"
DirectionKB4Xi['twentyone'] ['path2analyse']     = VersionKB4Xi['twentyone2ref4uri']

DirectionKB4Xi['twentytwo']    = {}
DirectionKB4Xi['twentytwo'] ['channel2publish']  = None
DirectionKB4Xi['twentytwo'] ['channel2consume']  = None
DirectionKB4Xi['twentytwo'] ['queue'] = None
DirectionKB4Xi['twentytwo'] ['function2target']  = None
DirectionKB4Xi['twentytwo'] ['number2process']   = None
DirectionKB4Xi['twentytwo'] ['name2process']     = None
DirectionKB4Xi['twentytwo'] ['status2process']   = None
DirectionKB4Xi['twentytwo'] ['cc2put']           = "<copy4xi>copy2twentytwo</copy4xi>"
DirectionKB4Xi['twentytwo'] ['cc2send']          = "<copy4xi>copy2twentytwo</copy4xi>"
DirectionKB4Xi['twentytwo'] ['cc2get']           = "<roger4xi>roger2twentytwo</roger4xi>"
DirectionKB4Xi['twentytwo'] ['cc2receive']       = "<roger4xi>roger2twentytwo</roger4xi>"
DirectionKB4Xi['twentytwo'] ['path2analyse']     = VersionKB4Xi['twentytwo2ref4uri']

DirectionKB4Xi['twentythree']  = {}
DirectionKB4Xi['twentythree'] ['channel2publish']  = None
DirectionKB4Xi['twentythree'] ['channel2consume']  = None
DirectionKB4Xi['twentythree'] ['queue'] = None
DirectionKB4Xi['twentythree'] ['function2target']  = None
DirectionKB4Xi['twentythree'] ['number2process']   = None
DirectionKB4Xi['twentythree'] ['name2process']     = None
DirectionKB4Xi['twentythree'] ['status2process']   = None
DirectionKB4Xi['twentythree'] ['cc2put']           = "<copy4xi>copy2twentythree</copy4xi>"
DirectionKB4Xi['twentythree'] ['cc2send']          = "<copy4xi>copy2twentythree</copy4xi>"
DirectionKB4Xi['twentythree'] ['cc2get']           = "<roger4xi>roger2twentythree</roger4xi>"
DirectionKB4Xi['twentythree'] ['cc2receive']       = "<roger4xi>roger2twentythree</roger4xi>"
DirectionKB4Xi['twentythree'] ['path2analyse']     = VersionKB4Xi['twentythree2ref4uri']

DirectionKB4Xi['twentyfour']   = {}
DirectionKB4Xi['twentyfour'] ['channel2publish']  = None
DirectionKB4Xi['twentyfour'] ['channel2consume']  = None
DirectionKB4Xi['twentyfour'] ['queue'] = None
DirectionKB4Xi['twentyfour'] ['function2target']  = None
DirectionKB4Xi['twentyfour'] ['number2process']   = None
DirectionKB4Xi['twentyfour'] ['name2process']     = None
DirectionKB4Xi['twentyfour'] ['status2process']   = None
DirectionKB4Xi['twentyfour'] ['cc2put']           = "<copy4xi>copy2twentyfour</copy4xi>"
DirectionKB4Xi['twentyfour'] ['cc2send']          = "<copy4xi>copy2twentyfour</copy4xi>"
DirectionKB4Xi['twentyfour'] ['cc2get']           = "<roger4xi>roger2twentyfour</roger4xi>"
DirectionKB4Xi['twentyfour'] ['cc2receive']       = "<roger4xi>roger2twentyfour</roger4xi>"
DirectionKB4Xi['twentyfour'] ['path2analyse']     = VersionKB4Xi['twentyfour2ref4uri']

DirectionKB4Xi['twentyfive']   = {}
DirectionKB4Xi['twentyfive'] ['channel2publish']  = None
DirectionKB4Xi['twentyfive'] ['channel2consume']  = None
DirectionKB4Xi['twentyfive'] ['queue'] = None
DirectionKB4Xi['twentyfive'] ['function2target']  = None
DirectionKB4Xi['twentyfive'] ['number2process']   = None
DirectionKB4Xi['twentyfive'] ['name2process']     = None
DirectionKB4Xi['twentyfive'] ['status2process']   = None
DirectionKB4Xi['twentyfive'] ['cc2put']           = "<copy4xi>copy2twentyfive</copy4xi>"
DirectionKB4Xi['twentyfive'] ['cc2send']          = "<copy4xi>copy2twentyfive</copy4xi>"
DirectionKB4Xi['twentyfive'] ['cc2get']           = "<roger4xi>roger2twentyfive</roger4xi>"
DirectionKB4Xi['twentyfive'] ['cc2receive']       = "<roger4xi>roger2twentyfive</roger4xi>"
DirectionKB4Xi['twentyfive'] ['path2analyse']     = VersionKB4Xi['twentyfive2ref4uri']

DirectionKB4Xi['twentysix']    = {}
DirectionKB4Xi['twentysix'] ['channel2publish']  = None
DirectionKB4Xi['twentysix'] ['channel2consume']  = None
DirectionKB4Xi['twentysix'] ['queue'] = None
DirectionKB4Xi['twentysix'] ['function2target']  = None
DirectionKB4Xi['twentysix'] ['number2process']   = None
DirectionKB4Xi['twentysix'] ['name2process']     = None
DirectionKB4Xi['twentysix'] ['status2process']   = None
DirectionKB4Xi['twentysix'] ['cc2put']           = "<copy4xi>copy2twentysix</copy4xi>"
DirectionKB4Xi['twentysix'] ['cc2send']          = "<copy4xi>copy2twentysix</copy4xi>"
DirectionKB4Xi['twentysix'] ['cc2get']           = "<roger4xi>roger2twentysix</roger4xi>"
DirectionKB4Xi['twentysix'] ['cc2receive']       = "<roger4xi>roger2twentysix</roger4xi>"
DirectionKB4Xi['twentysix'] ['path2analyse']     = VersionKB4Xi['twentysix2ref4uri']

DirectionKB4Xi['twentyseven']  = {}
DirectionKB4Xi['twentyseven'] ['channel2publish']  = None
DirectionKB4Xi['twentyseven'] ['channel2consume']  = None
DirectionKB4Xi['twentyseven'] ['queue'] = None
DirectionKB4Xi['twentyseven'] ['function2target']  = None
DirectionKB4Xi['twentyseven'] ['number2process']   = None
DirectionKB4Xi['twentyseven'] ['name2process']     = None
DirectionKB4Xi['twentyseven'] ['status2process']   = None
DirectionKB4Xi['twentyseven'] ['cc2put']           = "<copy4xi>copy2twentyseven</copy4xi>"
DirectionKB4Xi['twentyseven'] ['cc2send']          = "<copy4xi>copy2twentyseven</copy4xi>"
DirectionKB4Xi['twentyseven'] ['cc2get']           = "<roger4xi>roger2twentyseven</roger4xi>"
DirectionKB4Xi['twentyseven'] ['cc2receive']       = "<roger4xi>roger2twentyseven</roger4xi>"
DirectionKB4Xi['twentyseven'] ['path2analyse']     = VersionKB4Xi['twentyseven2ref4uri']

DirectionKB4Xi['twentyeight']  = {}
DirectionKB4Xi['twentyeight'] ['channel2publish']  = None
DirectionKB4Xi['twentyeight'] ['channel2consume']  = None
DirectionKB4Xi['twentyeight'] ['queue'] = None
DirectionKB4Xi['twentyeight'] ['function2target']  = None
DirectionKB4Xi['twentyeight'] ['number2process']   = None
DirectionKB4Xi['twentyeight'] ['name2process']     = None
DirectionKB4Xi['twentyeight'] ['status2process']   = None
DirectionKB4Xi['twentyeight'] ['cc2put']           = "<copy4xi>copy2twentyeight</copy4xi>"
DirectionKB4Xi['twentyeight'] ['cc2send']          = "<copy4xi>copy2twentyeight</copy4xi>"
DirectionKB4Xi['twentyeight'] ['cc2get']           = "<roger4xi>roger2twentyeight</roger4xi>"
DirectionKB4Xi['twentyeight'] ['cc2receive']       = "<roger4xi>roger2twentyeight</roger4xi>"
DirectionKB4Xi['twentyeight'] ['path2analyse']     = VersionKB4Xi['twentyeight2ref4uri']

DirectionKB4Xi['twentynine']  = {}
DirectionKB4Xi['twentynine'] ['channel2publish']  = None
DirectionKB4Xi['twentynine'] ['channel2consume']  = None
DirectionKB4Xi['twentynine'] ['queue'] = None
DirectionKB4Xi['twentynine'] ['function2target']  = None
DirectionKB4Xi['twentynine'] ['number2process']   = None
DirectionKB4Xi['twentynine'] ['name2process']     = None
DirectionKB4Xi['twentynine'] ['status2process']   = None
DirectionKB4Xi['twentynine'] ['cc2put']           = "<copy4xi>copy2twentynine</copy4xi>"
DirectionKB4Xi['twentynine'] ['cc2send']          = "<copy4xi>copy2twentynine</copy4xi>"
DirectionKB4Xi['twentynine'] ['cc2get']           = "<roger4xi>roger2twentynine</roger4xi>"
DirectionKB4Xi['twentynine'] ['cc2receive']       = "<roger4xi>roger2twentynine</roger4xi>"
DirectionKB4Xi['twentynine'] ['path2analyse']     = VersionKB4Xi['twentynine2ref4uri']

DirectionKB4Xi['thirty']       = {}
DirectionKB4Xi['thirty'] ['channel2publish']  = None
DirectionKB4Xi['thirty'] ['channel2consume']  = None
DirectionKB4Xi['thirty'] ['queue'] = None
DirectionKB4Xi['thirty'] ['function2target']  = None
DirectionKB4Xi['thirty'] ['number2process']   = None
DirectionKB4Xi['thirty'] ['name2process']     = None
DirectionKB4Xi['thirty'] ['status2process']   = None
DirectionKB4Xi['thirty'] ['cc2put']           = "<copy4xi>copy2thirty</copy4xi>"
DirectionKB4Xi['thirty'] ['cc2send']          = "<copy4xi>copy2thirty</copy4xi>"
DirectionKB4Xi['thirty'] ['cc2get']           = "<roger4xi>roger2thirty</roger4xi>"
DirectionKB4Xi['thirty'] ['cc2receive']       = "<roger4xi>roger2thirty</roger4xi>"
DirectionKB4Xi['thirty'] ['path2analyse']     = VersionKB4Xi['thirty2ref4uri']

DirectionKB4Xi['thirtyone']    = {}
DirectionKB4Xi['thirtyone'] ['channel2publish']  = None
DirectionKB4Xi['thirtyone'] ['channel2consume']  = None
DirectionKB4Xi['thirtyone'] ['queue'] = None
DirectionKB4Xi['thirtyone'] ['function2target']  = None
DirectionKB4Xi['thirtyone'] ['number2process']   = None
DirectionKB4Xi['thirtyone'] ['name2process']     = None
DirectionKB4Xi['thirtyone'] ['status2process']   = None
DirectionKB4Xi['thirtyone'] ['cc2put']           = "<copy4xi>copy2thirtyone</copy4xi>"
DirectionKB4Xi['thirtyone'] ['cc2send']          = "<copy4xi>copy2thirtyone</copy4xi>"
DirectionKB4Xi['thirtyone'] ['cc2get']           = "<roger4xi>roger2thirtyone</roger4xi>"
DirectionKB4Xi['thirtyone'] ['cc2receive']       = "<roger4xi>roger2thirtyone</roger4xi>"
DirectionKB4Xi['thirtyone'] ['path2analyse']     = VersionKB4Xi['thirtyone2ref4uri']

DirectionKB4Xi['thirtytwo']    = {}
DirectionKB4Xi['thirtytwo'] ['channel2publish']  = None
DirectionKB4Xi['thirtytwo'] ['channel2consume']  = None
DirectionKB4Xi['thirtytwo'] ['queue'] = None
DirectionKB4Xi['thirtytwo'] ['function2target']  = None
DirectionKB4Xi['thirtytwo'] ['number2process']   = None
DirectionKB4Xi['thirtytwo'] ['name2process']     = None
DirectionKB4Xi['thirtytwo'] ['status2process']   = None
DirectionKB4Xi['thirtytwo'] ['cc2put']           = "<copy4xi>copy2thirtytwo</copy4xi>"
DirectionKB4Xi['thirtytwo'] ['cc2send']          = "<copy4xi>copy2thirtytwo</copy4xi>"
DirectionKB4Xi['thirtytwo'] ['cc2get']           = "<roger4xi>roger2thirtytwo</roger4xi>"
DirectionKB4Xi['thirtytwo'] ['cc2receive']       = "<roger4xi>roger2thirtytwo</roger4xi>"
DirectionKB4Xi['thirtytwo'] ['path2analyse']     = VersionKB4Xi['thirtytwo2ref4uri']

DirectionKB4Xi['thirtythree']  = {}
DirectionKB4Xi['thirtythree'] ['channel2publish']  = None
DirectionKB4Xi['thirtythree'] ['channel2consume']  = None
DirectionKB4Xi['thirtythree'] ['queue'] = None
DirectionKB4Xi['thirtythree'] ['function2target']  = None
DirectionKB4Xi['thirtythree'] ['number2process']   = None
DirectionKB4Xi['thirtythree'] ['name2process']     = None
DirectionKB4Xi['thirtythree'] ['status2process']   = None
DirectionKB4Xi['thirtythree'] ['cc2put']           = "<copy4xi>copy2thirtythree</copy4xi>"
DirectionKB4Xi['thirtythree'] ['cc2send']          = "<copy4xi>copy2thirtythree</copy4xi>"
DirectionKB4Xi['thirtythree'] ['cc2get']           = "<roger4xi>roger2thirtythree</roger4xi>"
DirectionKB4Xi['thirtythree'] ['cc2receive']       = "<roger4xi>roger2thirtythree</roger4xi>"
DirectionKB4Xi['thirtythree'] ['path2analyse']     = VersionKB4Xi['thirtythree2ref4uri']

keys2DirectionKB4Xi = DirectionKB4Xi.keys()
key2DirectionKB4Xi  = 'thirteen'
#dynamic-end


# ------------------------------
# paths to input
# ------------------------------
master2ref4uri  = VersionKB4Xi['master2ref4uri']
dragon2ref4uri  = VersionKB4Xi['dragon2ref4uri']
#dynamic-start
zero2ref4uri    = VersionKB4Xi['zero2ref4uri']
one2ref4uri     = VersionKB4Xi['one2ref4uri']
two2ref4uri     = VersionKB4Xi['two2ref4uri']
three2ref4uri   = VersionKB4Xi['three2ref4uri']
four2ref4uri    = VersionKB4Xi['four2ref4uri']
five2ref4uri    = VersionKB4Xi['five2ref4uri']
six2ref4uri     = VersionKB4Xi['six2ref4uri']
seven2ref4uri   = VersionKB4Xi['seven2ref4uri']
eight2ref4uri   = VersionKB4Xi['eight2ref4uri'] 
nine2ref4uri    = VersionKB4Xi['nine2ref4uri'] 
ten2ref4uri     = VersionKB4Xi['ten2ref4uri'] 
eleven2ref4uri  = VersionKB4Xi['eleven2ref4uri']    
twelve2ref4uri  = VersionKB4Xi['twelve2ref4uri']             
thirteen2ref4uri    = VersionKB4Xi['thirteen2ref4uri']
fourteen2ref4uri    = VersionKB4Xi['fourteen2ref4uri']
fifteen2ref4uri     = VersionKB4Xi['fifteen2ref4uri']
sixteen2ref4uri     = VersionKB4Xi['sixteen2ref4uri']
seventeen2ref4uri   = VersionKB4Xi['seventeen2ref4uri']
eighteen2ref4uri    = VersionKB4Xi['eighteen2ref4uri']
nineteen2ref4uri    = VersionKB4Xi['nineteen2ref4uri']
twenty2ref4uri      = VersionKB4Xi['twenty2ref4uri']
twentyone2ref4uri   = VersionKB4Xi['twentyone2ref4uri']
twentytwo2ref4uri   = VersionKB4Xi['twentytwo2ref4uri']
twentythree2ref4uri = VersionKB4Xi['twentythree2ref4uri']
twentyfour2ref4uri  = VersionKB4Xi['twentyfour2ref4uri']
twentyfive2ref4uri  = VersionKB4Xi['twentyfive2ref4uri']
twentysix2ref4uri   = VersionKB4Xi['twentysix2ref4uri']
twentyseven2ref4uri = VersionKB4Xi['twentyseven2ref4uri']
twentyeight2ref4uri = VersionKB4Xi['twentyeight2ref4uri']
twentynine2ref4uri  = VersionKB4Xi['twentynine2ref4uri']
thirty2ref4uri      = VersionKB4Xi['thirty2ref4uri']
thirtyone2ref4uri   = VersionKB4Xi['thirtyone2ref4uri']
thirtytwo2ref4uri   = VersionKB4Xi['thirtytwo2ref4uri']
thirtythree2ref4uri = VersionKB4Xi['thirtythree2ref4uri']
#dynamic-end         

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4fecth" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4fecth():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 00A/33) OF SET2TRACE4FECTH - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 00B/33) OF SET2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 002A/33) OF SET2TRACE4FECTH - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 0033/33) OF SET2TRACE4FECTH - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi())
    # 10:55:18 01/09/15 FLE Standard Time 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4fetch" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4fetch():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 001A/33) of DENY2TRACE4FECTH: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  19:04:49 01/21/15 FLE Standard Time
    print("(Step 001B/33) OF DENY2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x02A9A250>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 001C/33) OF DENY2TRACE4FECTH - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 001D/33) OF DENY2TRACE4FECTH - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 001E/33) OF DENY2TRACE4FECTH - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEROOT4XI PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 001F/33) OF DENY2TRACE4FECTH - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 001Z/33) OF DENY2TRACE4FECTH *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 001G/33) OF DENY2TRACE4FECTH - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 002F/33) OF DENY2TRACE4FECTH - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 0033/33) OF SET2TRACE4FECTH - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi())
    # COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...)  19:04:49 01/21/15 FLE Standard Time
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x02A9A250>
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         # embedded trace for system programs
         'Pipe4Xi': 'NACK4TRACE',
         'Queue4Xi': 'NACK4TRACE',         
         'Process4Xi': 'NACK4TRACE'
         
         # no embedded application trace for big data
         #'automate2ref4uri': 'NACK4TRACE',
         #'gun2dragon4uri': 'NACK4TRACE',
         #'generate2gun4uri': 'NACK4TRACE',
         #'generate2shoot4uri': 'NACK4TRACE',
         #dynamic-start
         #'gun2zero4uri': 'NACK4TRACE',
         #'gun2one4uri': 'NACK4TRACE',
         #'gun2thirtythree4uri': 'NACK4TRACE',
         #dynamic-end
         #'shoot2dragon4uri': 'NACK4TRACE',
         #dynamic-start
         #'shoot2zero4uri': 'NACK4TRACE',
         #'shoot2one4uri': 'NACK4TRACE',
         #'shoot2thirtythree4uri': 'NACK4TRACE'
         #dynamic-end
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # Pipe4Xi
        # Process4Xi
        # Queue4Xi
        # ...

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    # 

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):

    class2print  = "automate2ref4uri.py"
    method2print = "automate2ref4uri.py" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-automate2ref4uri.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing automate2ref4uri.py.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">automate2ref4uri.py sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-automate2ref4uri.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for automate2ref4uri.py.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-automate2ref4uri.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for automate2ref4uri.py.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of automate2ref4uri.py.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global ack2message4index

    global ack4queues
    global nack4queues

    global ack4pipes
    global nack4pipes

    global ack4process
    global nack4process

    global ack4start
    global nack4start   
        
    global ack4run
    global nack4run
    
    global master2ref4uri
    global dragon2ref4uri   
    
    #dynamic-start
    global zero2ref4uri
    global one2ref4uri
    global two2ref4uri 
    global three2ref4uri 
    global four2ref4uri
    global five2ref4uri
    global six2ref4uri 
    global seven2ref4uri 
    global eight2ref4uri 
    global nine2ref4uri
    global ten2ref4uri
    global eleven2ref4uri
    global twelve2ref4uri
    global thirteen2ref4uri
    global fourteen2ref4uri
    global fifteen2ref4uri
    global sixteen2ref4uri
    global seventeen2ref4uri
    global eighteen2ref4uri
    global nineteen2ref4uri
    global twenty2ref4uri
    global twentyone2ref4uri
    global twentytwo2ref4uri
    global twentythree2ref4uri
    global twentyfour2ref4uri
    global twentyfive2ref4uri
    global twentysix2ref4uri
    global twentyseven2ref4uri
    global twentyeight2ref4uri
    global twentynine2ref4uri
    global thirty2ref4uri
    global thirtyone2ref4uri
    global thirtytwo2ref4uri
    global thirtythree2ref4uri
    global DirectionKB4Xi
    global keys2DirectionKB4Xi
    global key2DirectionKB4Xi
    #dynamic-end
    
    global path2temp4xi

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0A/33) OF AUTOMATE2REF4URI - SET T2XI TO: ", t2xi)  
    # <print4xi.Print4Xi object at 0x02A9A250> 

    set2trace4fecth()                                                                                               # trace all classes and functions in the system
    deny2trace4fetch()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    

    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()
    
       
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print ('(STEP 1/33) OF AUTOMATE2REF4URI - TRYING TO PRINT INPUT PATHS ', time4xi())
    try:
        print ('(STEP 1A/33) OF AUTOMATE2REF4URI - MASTER2REF4URI: ', master2ref4uri)
        print ('(STEP 1B/33) OF AUTOMATE2REF4URI - DRAGON2REF4URI: ', dragon2ref4uri)
        
        #dynamic-start
        print ('(STEP 1C/33) OF AUTOMATE2REF4URI - ZERO2REF4URI: ', zero2ref4uri)
        print ('(STEP 1D/33) OF AUTOMATE2REF4URI - ONE2REF4URI: ', one2ref4uri)
        print ('(STEP 1E/33) OF AUTOMATE2REF4URI - TWO2REF4URI: ', two2ref4uri)
        print ('(STEP 1F/33) OF AUTOMATE2REF4URI - THREE2REF4URI: ', three2ref4uri)
        print ('(STEP 1G/33) OF AUTOMATE2REF4URI - FOUR2REF4URI: ', four2ref4uri)
        print ('(STEP 1H/33) OF AUTOMATE2REF4URI - FIVE2REF4URI: ', five2ref4uri)
        print ('(STEP 1J/33) OF AUTOMATE2REF4URI - SIX2REF4URI: ', six2ref4uri)
        print ('(STEP 1K/33) OF AUTOMATE2REF4URI - SEVEN2REF4URI: ', seven2ref4uri)
        print ('(STEP 1L/33) OF AUTOMATE2REF4URI - EIGHT2REF4URI: ', eight2ref4uri)
        print ('(STEP 1M/33) OF AUTOMATE2REF4URI - NINE2REF4URI: ', nine2ref4uri)
        print ('(STEP 1N/33) OF AUTOMATE2REF4URI - TEN2REF4URI: ', ten2ref4uri)
        print ('(STEP 1O/33) OF AUTOMATE2REF4URI - ELEVEN2REF4URI: ', eleven2ref4uri)
        print ('(STEP 1P/33) OF AUTOMATE2REF4URI - TWELVE2REF4URI: ', twelve2ref4uri)
        print ('(STEP 1D13/33) OF AUTOMATE2REF4URI - THIRTEEN2REF4URI: ', thirteen2ref4uri)
        print ('(STEP 1D14/33) OF AUTOMATE2REF4URI - FOURTEEN2REF4URI: ', fourteen2ref4uri)
        print ('(STEP 1D15/33) OF AUTOMATE2REF4URI - FIFTEEN2REF4URI: ', fifteen2ref4uri)
        print ('(STEP 1D16/33) OF AUTOMATE2REF4URI - SIXTEEN2REF4URI: ', sixteen2ref4uri)
        print ('(STEP 1D17/33) OF AUTOMATE2REF4URI - SEVENTEEN2REF4URI: ', seventeen2ref4uri)
        print ('(STEP 1D18/33) OF AUTOMATE2REF4URI - EIGHTEEN2REF4URI: ', eighteen2ref4uri)
        print ('(STEP 1D19/33) OF AUTOMATE2REF4URI - NINETEEN2REF4URI: ', nineteen2ref4uri)
        print ('(STEP 1D20/33) OF AUTOMATE2REF4URI - TWENTY2REF4URI: ', twenty2ref4uri)
        print ('(STEP 1D21/33) OF AUTOMATE2REF4URI - TWENTYONE2REF4URI: ', twentyone2ref4uri)
        print ('(STEP 1D22/33) OF AUTOMATE2REF4URI - TWENTYTWO2REF4URI: ', twentytwo2ref4uri)
        print ('(STEP 1D23/33) OF AUTOMATE2REF4URI - TWENTYTHREE2REF4URI: ', twentythree2ref4uri)
        print ('(STEP 1D24/33) OF AUTOMATE2REF4URI - TWENTYFOUR2REF4URI: ', twentyfour2ref4uri)
        print ('(STEP 1D25/33) OF AUTOMATE2REF4URI - TWENTYFIVE2REF4URI: ', twentyfive2ref4uri)
        print ('(STEP 1D26/33) OF AUTOMATE2REF4URI - TWENTYSIX2REF4URI: ', twentysix2ref4uri)
        print ('(STEP 1D27/33) OF AUTOMATE2REF4URI - TWENTYSEVEN2REF4URI: ', twentyseven2ref4uri)
        print ('(STEP 1D28/33) OF AUTOMATE2REF4URI - TWENTYEIGHT2REF4URI: ', twentyeight2ref4uri)
        print ('(STEP 1D29/33) OF AUTOMATE2REF4URI - TWENTYNINE2REF4URI: ', twentynine2ref4uri)
        print ('(STEP 1D30/33) OF AUTOMATE2REF4URI - THIRTY2REF4URI: ', thirty2ref4uri)
        print ('(STEP 1D31/33) OF AUTOMATE2REF4URI - THIRTYONE2REF4URI: ', thirtyone2ref4uri)
        print ('(STEP 1D32/33) OF AUTOMATE2REF4URI - THIRTYTWO2REF4URI: ', thirtytwo2ref4uri)
        print ('(STEP 1D33/33) OF AUTOMATE2REF4URI - THIRTYTHREE2REF4URI: ', thirtythree2ref4uri)
        # (STEP 1A/33) OF AUTOMATE2REF4URI - MASTER2REF4URI:  J://temp//yosense//test2master//
        # DRAGON2REF4URI:  F://temp//yosense//test2dragon//
        # ZERO2REF4URI:  D://temp//yosense//test2zero//
        # ONE2REF4URI:  G://temp//yosense//test2one//
        # TWO2REF4URI:  H://temp//yosense//test2two//
        # THREE2REF4URI:  I://temp//yosense//test2three//
        # FOUR2REF4URI:  K://temp//yosense//test2four//
        # FIVE2REF4URI:  L://temp//yosense//test2five//
        # SIX2REF4URI:  M://temp//yosense//test2six//
        # SEVEN2REF4URI:  N://temp//yosense//test2seven//
        # EIGHT2REF4URI:  O://temp//yosense//test2eight//
        # NINE2REF4URI:  P://temp//yosense//test2nine//
        # TEN2REF4URI:  Q://temp//yosense//test2ten//
        # ELEVEN2REF4URI:  F://temp//yosense//test2eleven//
        # TWELVE2REF4URI:  G://temp//yosense//test2twelve//
        # THIRTEEN2REF4URI:  M://temp//yosense//test2thirteen//
        # FOURTEEN2REF4URI:  K://temp//yosense//test2fourteen//
        # FIFTEEN2REF4URI:  L://temp//yosense//test2fifteen//
        # SIXTEEN2REF4URI:  M://temp//yosense//test2sixteen//
        # SEVENTEEN2REF4URI:  N://temp//yosense//test2seventeen//
        # EIGHTEEN2REF4URI:  O://temp//yosense//test2eighteen//
        # NINETEEN2REF4URI:  P://temp//yosense//test2nineteen//
        # TWENTY2REF4URI:  Q://temp//yosense//test2twenty//
        # TWENTYONE2REF4URI:  F://temp//yosense//test2twentyone//
        # TWENTYTWO2REF4URI:  G://temp//yosense//test2twentytwo//
        # TWENTYTHREE2REF4URI:  I://temp//yosense//test2twentythree//
        # TWENTYFOUR2REF4URI:  K://temp//yosense//test2twentyfour//
        # TWENTYFIVE2REF4URI:  L://temp//yosense//test2twentyfive//
        # TWENTYSIX2REF4URI:  M://temp//yosense//test2twentysix//
        # TWENTYSEVEN2REF4URI:  N://temp//yosense//test2twentyseven//
        # TWENTYEIGHT2REF4URI:  O://temp//yosense//test2twentyeight//
        # TWENTYNINE2REF4URI:  P://temp//yosense//test2twentynine//
        # THIRTY2REF4URI:  Q://temp//yosense//test2thirty//
        # THIRTYONE2REF4URI:  F://temp//yosense//test2thirtyone//
        # THIRTYTWO2REF4URI:  G://temp//yosense//test2thirtytwo//
        # THIRTYTHREE2REF4URI:  M://temp//yosense//test2thirtythree//
    except:                                       
        print ('(STEP 1Z/33) OF AUTOMATE2REF4URI *** FAILED TO PRINT INPUT PATHS ', time4xi())
    #dynamic-end
    
   #dynamic-start
    print("(STEP 3D13/33) OF AUTOMATE2REF4URI - TRYING TO PRINT DirectionKB4Xi")
    
    keys2direction = DirectionKB4Xi.keys()
    for key2direction in sorted(keys2direction):
        try: 
            print(DirectionKB4Xi[key2direction] ['channel2publish'])
        except:
            print("(STEP 3D13Z/33) OF AUTOMATE2REF4URI *** FAILED TO PRINT channel2publish")
        try:           
            print(DirectionKB4Xi[key2direction] ['channel2consume'])
        except:
            print("(STEP 3D13Z/33) OF AUTOMATE2REF4URI *** FAILED TO PRINT channel2consume")
        try:        
            print(DirectionKB4Xi[key2direction] ['queue'])
        except:
            print("(STEP 3D13Z/33) OF AUTOMATE2REF4URI *** FAILED TO PRINT queue")
        try:        
            print(DirectionKB4Xi[key2direction] ['number2process'])
        except:
            print("(STEP 3D13Z/33) OF AUTOMATE2REF4URI *** FAILED TO PRINT number2process")
        try:        
            print(DirectionKB4Xi[key2direction] ['name2process'])
        except:
            print("(STEP 3D13Z/33) OF AUTOMATE2REF4URI *** FAILED TO PRINT name2process")
        try:        
            print(DirectionKB4Xi[key2direction] ['status2process'])
        except:
            print("(STEP 3D13Z/33) OF AUTOMATE2REF4URI *** FAILED TO PRINT status2process")
        try:        
            print(DirectionKB4Xi[key2direction] ['cc2put'])
        except:
            print("(STEP 3D13Z/33) OF AUTOMATE2REF4URI *** FAILED TO PRINT cc2put")
        try:        
            print(DirectionKB4Xi[key2direction] ['cc2send'])
        except:
            print("(STEP 3D13Z/33) OF AUTOMATE2REF4URI *** FAILED TO PRINT cc2send")
        try:        
            print(DirectionKB4Xi[key2direction] ['cc2get'])
        except:
            print("(STEP 3D13Z/33) OF AUTOMATE2REF4URI *** FAILED TO PRINT cc2get")
        try:        
            print(DirectionKB4Xi[key2direction] ['cc2receive'])
        except:
            print("(STEP 3D13Z/33) OF AUTOMATE2REF4URI *** FAILED TO PRINT cc2receive")
        try:    
            print(DirectionKB4Xi[key2direction] ['path2analyse'])
        except:
            print("(STEP 3D13Z/33) OF AUTOMATE2REF4URI *** FAILED TO PRINT path2analyse")    
        # ...
        # None
        # None
        # None
        # None
        # None
        # None
        # <copy4xi>copy2eight</copy4xi>
        # <copy4xi>copy2eight</copy4xi>
        # <roger4xi>roger2eight</roger4xi>
        # <roger4xi>roger2eight</roger4xi>
        # O://temp//yosense//test2eight// 
        # ...
           
    #dynamic-end
    # =============================================================================================   
    # (Step 3/33)
    # =============================================================================================       
    print("(STEP 3A/33) OF AUTOMATE2REF4URI - CREATING DRAGON PIPE WITH CONSUMER AND PUBLISHER ENDS ", time4xi())
    # 
    try:
        # -----------------------------------------------------------------------------------------    
        # DRAGON PIPE
        # -----------------------------------------------------------------------------------------     
        pipe2dragon_consumer_channel, pipe2dragon_publisher_channel = Pipe4Xi()
        print("(STEP 3B1/33) OF AUTOMATE2REF4URI - CREATED PIPE2DRAGON_CONSUMER_CHANNEL")   
        print(pipe2dragon_consumer_channel)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x02B8FF30> 
        print("(STEP 3B2/33) OF AUTOMATE2REF4URI - CREATED PIPE2DRAGON_PUBLISHER_CHANNEL")  
        print(pipe2dragon_publisher_channel)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x02B8FF10>
    except:
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        print("(STEP ZB/33) OF AUTOMATE2REF4URI *** FAILED TO CREATE DRAGON PIPE WITH CONSUMER AND PUBLISHER ENDS ", time4xi())  
    
    #dynamic-start
    print("(STEP 3D13A/33) OF AUTOMATE2REF4URI - TRYING TO CREATE CONSUMER AND PUBLISHER CHANNELS WITH PIPE4XI")                         
    keys2direction = DirectionKB4Xi.keys()
    for key2direction in keys2direction:
        try:
            DirectionKB4Xi[key2direction] ['channel2consume'], DirectionKB4Xi[key2direction] ['channel2publish'] = Pipe4Xi()     
            print("(STEP 3D13B/33) OF AUTOMATE2REF4URI - CREATED CONSUMER CHANNEL TO DIRECTION ", key2direction)   
            print(DirectionKB4Xi[key2direction] ['channel2consume'])
            # DIRECTION  zero <pipeconnection4xi.PipeConnection4Xi object at 0x02BB57B0>
            # ...
            # CONSUMER CHANNEL TO DIRECTION  twentyeight <pipeconnection4xi.PipeConnection4Xi object at 0x02B8FF90> 
            # ...
            print("(STEP 3D13C/33) OF AUTOMATE2REF4URI - CREATED PUBLISHER CHANNEL TO DIRECTION ", key2direction)  
            print(DirectionKB4Xi[key2direction] ['channel2publish'])
            # PUBLISHER CHANNEL TO DIRECTION  zero <pipeconnection4xi.PipeConnection4Xi object at 0x02BB5790>
            # ...
            # PUBLISHER CHANNEL TO DIRECTION  twentyeight <pipeconnection4xi.PipeConnection4Xi object at 0x02B8FF50>
            # ...
        except:
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------     
            print("(STEP 3ZD13/33) OF AUTOMATE2REF4URI *** FAILED TO CREATE PIPE TO DIRECTION ", key2direction)
                                                      
    #dynamic-end
    try:
        # -----------------------------------------------------------------------------------------    
        # DRAGON QUEUE
        # -----------------------------------------------------------------------------------------     
        print('=' *33)    
        print("(STEP 3L1/33) OF AUTOMATE2REF4URI - CREATING QUEUE2DRAGON")
        print('=' *33)           
             
        queue2dragon = Queue4Xi()
        
        print('=' *33)    
        print("(STEP 3L2/33) OF AUTOMATE2REF4URI - CREATED QUEUE2DRAGON: ", queue2dragon)
        # QUEUE2DRAGON:  <queue4xi.Queue4Xi object at 0x02BB5810>
    except:
        print("(STEP 3ZL/33) OF AUTOMATE2REF4URI *** FAILED TO CREATE QUEUE2DRAGON ***")            
   
    #dynamic-start
    print("(STEP 3V13A/33) OF AUTOMATE2REF4URI - TRYING TO CREATE QUEUES DYNAMICALLY")
    keys2direction = DirectionKB4Xi.keys()
    for key2direction in sorted(keys2direction):
        try:
            DirectionKB4Xi[key2direction] ['queue'] = Queue4Xi()
            print("(STEP 3V13B/33) OF AUTOMATE2REF4URI - CREATED FOR DIRECTION ", key2direction, " QUEUE: ", DirectionKB4Xi[key2direction] ['queue'])
            # zero  QUEUE:  <queue4xi.Queue4Xi object at 0x02BB58F0>
            # ...
            # fifteen  QUEUE:  <queue4xi.Queue4Xi object at 0x02DAE2B0>
            # ... 
            # thirtythree  QUEUE:  <queue4xi.Queue4Xi object at 0x02DAE950>
        except:
            print("(STEP 3V13Z/33) OF AUTOMATE2REF4URI *** FAILED TO CREATE FOR DIRECTION ", key2direction, " QUEUE")
            #     
             
    #dynamic-end
    
    # =============================================================================================   
    # (Step 4/33) - DRAGON COMMAND AND CONTROL PUT TO QUEUE
    # =============================================================================================  
    print("(STEP 4A1/33) OF AUTOMATE2REF4URI - TRYING TO PUT DRAGON COMMAND AND CONTROL MESSAGES ", time4xi())
    try:
        # -------------------------------------------------------------------------------------------------
        # PUT COMMAND AND CONTROL MESSAGES TO DRAGON                         
        # ------------------------------------------------------------------------------------------------- 
        message2put4dragon = "<copy4xi>copy2dragon</copy4xi>"
        queue2dragon.put(message2put4dragon)
        print("(STEP 4A2/33) OF AUTOMATE2REF4URI - PUT TO QUEUE2DRAGON: ", queue2dragon, " MESSAGE2PUT4DRAGON: " , message2put4dragon)
        # PUT TO QUEUE2DRAGON:  <queue4xi.Queue4Xi object at 0x02BB5810>  MESSAGE2PUT4DRAGON:  <copy4xi>copy2dragon</copy4xi>
    except:
        print("(STEP 4Z1/33) OF AUTOMATE2REF4URI *** FAILED TO PUT DRAGON COMMAND AND CONTROL MESSAGES ", time4xi())

    #dynamic-start
    print("(STEP 4B1/33) OF AUTOMATE2REF4URI - TRYING TO PUT COMMAND AND CONTROL MESSAGES DYNAMICALLY ")
    keys2direction = DirectionKB4Xi.keys()
    for key2direction in sorted(keys2direction):
        try:
           cc2put = DirectionKB4Xi[key2direction] ['cc2put']
           queue2cc = DirectionKB4Xi[key2direction] ['queue']
           queue2cc.put(cc2put)
           print("(STEP 4B2/33) OF AUTOMATE2REF4URI - PUT TO DIRECTION ", key2direction, " VIA QUEUE ", queue2cc, " COMMAND CONTROL: " , cc2put)
           # PUT TO DIRECTION  zero  VIA QUEUE  <queue4xi.Queue4Xi object at 0x02BB58F0>  COMMAND CONTROL:  <copy4xi>copy2zero</copy4xi>
           # ... 
           # PUT TO DIRECTION  twentyone  VIA QUEUE  <queue4xi.Queue4Xi object at 0x02BB5FB0>  COMMAND CONTROL:  <copy4xi>copy2twentyone</copy4xi>
           # ...
           # PUT TO DIRECTION  thirtythree  VIA QUEUE  <queue4xi.Queue4Xi object at 0x02C810D0>  COMMAND CONTROL:  <copy4xi>copy2thirtythree</copy4xi>
           
        except:
           print("(STEP 4Z2/33) OF AUTOMATE2REF4URI *** FAILED TO PUT COMMAND AND CONTROL MESSAGE TO DIRECTION ", key2direction)
          
    #dynamic-end             
    
    print("(STEP 4C1/33) OF AUTOMATE2REF4URI - TRYING TO SEND COMMAND AND CONTROL MESSAGES TO DRAGON PIPE ", time4xi()) 
    try:    
        # -------------------------------------------------------------------------------------------------
        # SEND COMMAND AND CONTROL MESSAGES TO DRAGON                          
        # -------------------------------------------------------------------------------------------------                 
        message2send4dragon = "<copy4xi>copy2dragon</copy4xi>"
        pipe2dragon_publisher_channel.send(message2send4dragon)
        print("(STEP 4C2/33) OF AUTOMATE2REF4URI - SENT TO PIPE2DRAGON_PUBLISHER_CHANNEL: ", pipe2dragon_publisher_channel, " MESSAGE2SEND4DRAGON: " , message2send4dragon)
        # SENT TO PIPE2DRAGON_PUBLISHER_CHANNEL:  <pipeconnection4xi.PipeConnection4Xi object at 0x02B8FF10>  MESSAGE2SEND4DRAGON:  <copy4xi>copy2dragon</copy4xi>
    except:
        print("(STEP 4Z3/33) OF AUTOMATE2REF4URI *** FAILED SEND COMMAND AND CONTROL MESSAGES TO DRAGON PIPE ", time4xi())   
    
    
    #dynamic-start
    print("(STEP 4D1/33) OF AUTOMATE2REF4URI - TRYING TO SEND COMMAND AND CONTROL MESSAGES DYNAMICALLY") 
    keys2direction = DirectionKB4Xi.keys()
    for key2direction in sorted(keys2direction):
        try:
           cc2send  = DirectionKB4Xi[key2direction] ['cc2send']
           channel2cc  = DirectionKB4Xi[key2direction] ['channel2publish']
           channel2cc.send(cc2send)
           print("(STEP 4D2/33) OF AUTOMATE2REF4URI - SENT TO DIRECTION ", key2direction, " VIA CHANNEL ", channel2cc, " COMMAND CONTROL: " , cc2send)
           # SENT TO DIRECTION  zero  VIA CHANNEL  <pipeconnection4xi.PipeConnection4Xi object at 0x02BB5790>  COMMAND CONTROL:  <copy4xi>copy2zero</copy4xi>
           # ... 
           # SENT TO DIRECTION  seventeen  VIA CHANNEL  <pipeconnection4xi.PipeConnection4Xi object at 0x02C999F0>  COMMAND CONTROL:  <copy4xi>copy2seventeen</copy4xi>
           # ...
           # SENT TO DIRECTION  thirtythree  VIA CHANNEL  <pipeconnection4xi.PipeConnection4Xi object at 0x02BB56B0>  COMMAND CONTROL:  <copy4xi>copy2thirtythree</copy4xi>
        except:
           print("(STEP 4Z4/33) OF AUTOMATE2REF4URI *** FAILED TO SEND COMMAND AND CONTROL MESSAGE TO DIRECTION ", key2direction) 
    #dynamic-end
    
    
    print("(STEP 8A1/33) OF AUTOMATE2REF4URI - TRYING WITH PARAMETERS FOR DRAGON ", time4xi())                    
    try:
        # ------------------------------------------------------------------------------ 
        # DRAGON-GUN WITH MULTIPROCESSING4XI
        # ------------------------------------------------------------------------------     
        print("(STEP 8A2/33) OF AUTOMATE2REF4URI - PASSING QUEUE2DRAGON ", queue2dragon)
        # PASSING QUEUE2DRAGON  <queue4xi.Queue4Xi object at 0x02BB5810>
        print("(STEP 8A3/33) OF AUTOMATE2REF4URI - PASSING PIPE2DRAGON_CONSUMER_CHANNEl ", pipe2dragon_consumer_channel)
        # PASSING PIPE2DRAGON_CONSUMER_CHANNEl  <pipeconnection4xi.PipeConnection4Xi object at 0x02B8FF30>
        print("(STEP 8A4/33) OF AUTOMATE2REF4URI - PASSING PIPE2DRAGON_PUBLISHER_CHANNEL ", pipe2dragon_publisher_channel )
        # PASSING PIPE2DRAGON_PUBLISHER_CHANNEL  <pipeconnection4xi.PipeConnection4Xi object at 0x02B8FF10>
        print("(STEP 8A5/33) OF AUTOMATE2REF4URI - PASSING DRAGON2ANALYSE4SEARCH ", dragon2ref4uri)
        # PASSING DRAGON2ANALYSE4SEARCH  F://temp//yosense//test2dragon//
        print("(STEP 8A6/33) OF AUTOMATE2REF4URI - USING TARPEGT FUNCTION GUN2DRAGON4SEARCH ", gun2dragon4uri)
        # USING TARPEGT FUNCTION GUN2DRAGON4SEARCH  <function gun2dragon4uri at 0x029B4618>
    except:
        print("(STEP 8Z1/33) OF AUTOMATE2REF4URI *** FAILED WITH PARAMETERS FOR DRAGON ", time4xi())
     
    print("(STEP 8B1/33) OF AUTOMATE2REF4URI - TRYING TO CREATE DRAGON PROCESS WITH TARGET FUNCTION ", time4xi())            
    try:         
        # -----------------------------------------------------------------------------------------    
        # DRAGON-PROCESS WITH TARGET FUNCTION CREATION
        # -----------------------------------------------------------------------------------------                     
        p2dragon = Process4Xi(target=gun2dragon4uri, args=(queue2dragon, pipe2dragon_consumer_channel, pipe2dragon_publisher_channel, dragon2ref4uri))
        print("(STEP 8B2/33) OF AUTOMATE2REF4URI - CREATED DRAGON PROCESS OBJECT P2DRAGON: ", p2dragon)                     
        # 
    except:
        print("(STEP 8Z2/33) OF AUTOMATE2REF4URI *** FAILED TO CREATE DRAGON PROCESS WITH TARGET FUNCTION ", time4xi())
    
    try:        
        # -----------------------------------------------------------------------------------------    
        # DRAGON-PROCESS NAME
        # -----------------------------------------------------------------------------------------                        
        name2dragon = p2dragon.name
        print("(STEP 8B3/33) OF AUTOMATE2REF4URI - CREATED DRAGON PROCESS NAME: ", name2dragon) 
        # CREATED DRAGON PROCESS NAME:  Process4Xi-1
    except:
        print("(STEP 8Z3/33) OF AUTOMATE2REF4URI *** FAILED TO GET NAME OF DRAGON PROCESS ", time4xi())
            
    try:         
        # -----------------------------------------------------------------------------------------    
        # DRAGON-PROCESS START
        # ----------------------------------------------------------------------------------------- 
        p2dragon.start()
        print("(STEP 8B4/33) OF AUTOMATE2REF4URI - STARTED DRAGON PROCESS NAME: ", name2dragon)
        # STARTED DRAGON PROCESS NAME:  Process4Xi-1
    except:
        print("(STEP 8Z4/33) OF AUTOMATE2REF4URI *** FAILED TO START PROCESS ", time4xi())
        
    try:        
        # -----------------------------------------------------------------------------------------    
        # DRAGON-PROCESS ALIVE CHECK
        # -----------------------------------------------------------------------------------------                   
        status4p2dragon = p2dragon.is_alive()
        print("(STEP 8B5/33) OF AUTOMATE2REF4URI - DRAGON PROCESS STATUS: ", status4p2dragon)
        # DRAGON PROCESS STATUS:  True
    except:
        print("(STEP 8Z5/33) OF AUTOMATE2REF4URI *** FAILED TO CHECK IF DRAGON PROCESS IS ALIVE ", time4xi())
        
                
    try:            
        # -----------------------------------------------------------------------------------------    
        # DRAGON-PROCESS RUN
        # -----------------------------------------------------------------------------------------
        p2dragon.run()
        print("(STEP 8B6/33) OF AUTOMATE2REF4URI - PERFORMED RUN COMMAND TO DRAGON PROCESS NAME: ", name2dragon)
        # PERFORMED RUN COMMAND TO DRAGON PROCESS NAME:  Process4Xi-1
        ack4run = True 
    except:
        print("(STEP 8Z6/33) OF AUTOMATE2REF4URI *** FAILED TO RUN DRAGON PROCESS ", time4xi())
        

    try:
        # --------------------------------------------------------------------------------
        # DRAGON-PROCESS - GETTING COMMUNICATION AND CONTROL MESSAGES FROM QUEUES                         
        # --------------------------------------------------------------------------------   
        print("(STEP 8B7/33) OF AUTOMATE2REF4URI - GETTING COMMUNICATION AND CONTROL MESSAGES FROM DRAGON QUEUE ", time4xi())
        # 
        message2get4dragon = queue2dragon.get()
        print("(Step 8B8/33) OF AUTOMATE2REF4URI - GOT FROM QUEUE2DRAGON: ", queue2dragon, " MESSAGE: ", message2get4dragon)
        # GOT FROM QUEUE2DRAGON:  <queue4xi.Queue4Xi object at 0x02BB5810>  MESSAGE:  <roger4xi>roger2dragon</roger4xi>
    except:
        print("(STEP 8Z8/33) OF AUTOMATE2REF4URI *** FAILED GETTING COMMUNICATION AND CONTROL MESSAGES FROM DRAGON QUEUE ", time4xi()) 
                    
    try:
        # --------------------------------------------------------------------------------
        # DRAGON-PROCESS - RECEIVING COMMUNICATION AND CONTROL MESSAGES FROM PIPES                          
        # --------------------------------------------------------------------------------       
        print("(Step 8B8/33) OF AUTOMATE2REF4URI - RECEIVING COMMUNICATION AND CONTROL MESSAGES FROM DRAGON PIPE ", time4xi())  
        # 
        message2receive4dragon = pipe2dragon_consumer_channel.recv()
        print("(Step 8B9/33) OF AUTOMATE2REF4URI - RECEIVED FROM PIPE2DRAGON_CONSUMER_CHANNEL: ", pipe2dragon_consumer_channel, " MESSAGE: ", message2receive4dragon)
        # RECEIVED FROM PIPE2DRAGON_CONSUMER_CHANNEL:  <pipeconnection4xi.PipeConnection4Xi object at 0x02B8FF30>  MESSAGE:  <roger4xi>roger2dragon</roger4xi>
    except:
        print("(STEP 8Z8/33) OF AUTOMATE2REF4URI *** FAILED GETTING COMMUNICATION AND CONTROL MESSAGES FROM DRAGON PIPE ", time4xi())    

    #dynamic-start
    path2read4xi  = VersionKB4Xi['folder2read4dragon'] 
    print ('(STEP 9A/33) OF AUTOMATE2REF4URI - PATH2READ4XI: ', path2read4xi)
    # E://temp//dragonize//in// 
    
    path2write4xi = VersionKB4Xi['folder2write4dragon']
    print ('(STEP 9B/33) OF AUTOMATE2REF4URI - PATH2WRITE4XI: ', path2write4xi)
    # E://temp//dragonize//out//
             
    # -------------------------------------------------------------------------------------------------
    # UPDATE SYSTEM PATH - GENERATED MODULES ARE NOT COPIED TO SOURCE FOLDER BECAUSE THEY ARE TEMPORARY
    # -------------------------------------------------------------------------------------------------    
    print ("(STEP 9C/33) OF AUTOMATE2REF4URI - TRYING TO MAKE SURE GENERATED SHOOT MODULE CAN BE IMPORTED FROM PATH2WRITE4XI ", path2write4xi)
    # E://temp//dragonize//out// 
    try:
        sys.path.index(path2write4xi)
        print ("(STEP 9D/33) OF AUTOMATE2REF4URI - KEPT SYSTEM PATH, FOUND EXISTING: ", path2write4xi)
        # 
    except:
        sys.path.append(path2write4xi)
        print ("(STEP 9E/33) OF AUTOMATE2REF4URI - UPDATED SYSTEM PATH WITH PATH2WRITE4XI: ", sys.path) 
        # ['E:\\STUDIO4XI\\Python\\3.3\\src', 'd:\\Python33', 'C:\\Windows\\SYSTEM32\\python33.zip', 'd:\\Python33\\DLLs', 'd:\\Python33\\lib',
        #  'd:\\Python33\\lib\\site-packages', '..//..//..//..//sw4xi//python33//lib//multiprocessing//', 
        #  '..//..//..//..//sw4xi//python33//lib//multiprocessing4xi//', '..//..//..//..//studio4xi//python//3.3//src//',
        #  '..//..//..//..//sw4xi//python33//zap//', 
        #  '..//..//..//..//scope4xi//041721//zap//lib//a//'
        #  ...
        #  '..//..//..//..//scope4xi//041721//zap//lib//z//',
        #  '..//..//..//..//scope4xi//041721//zap//lib//_//',
        #  'E://temp//dragonize//out//']  <-- this one is important!

             
    # -------------------------------------------------------------------------------------------------
    # GENERATE CODE FOR SHOTS DYNAMICALLY
    # -------------------------------------------------------------------------------------------------     
    print("(STEP 10A0/33) OF AUTOMATE2REF4URI - TRYING TO GENERATE CODE FOR SHOTS DYNAMICALLY") 
    # 
    keys2direction = DirectionKB4Xi.keys()        
    for file2walk in DirectoryWalker(path2read4xi):
        if os.path.isdir(file2walk):
            print ("(STEP 10A1/33) OF AUTOMATE2REF4URI - DIRECTORY: " + file2walk + '\n')
            # 
        if os.path.isfile(file2walk):
            string2look = "shoot2dragon4uri"
            index2look = str.find(file2walk,string2look) 
            if index2look == -1:
                pass
            else:
                print ("(STEP 10A2/33) OF AUTOMATE2REF4URI - ACCEPTED INPUT FILE: " + file2walk + '\n')
                # E://temp//dragonize//in//shoot2dragon4uri.py
                for key2direction in sorted(keys2direction):
                    try:        
                        generate2shoot4uri(file2walk, direction2process = key2direction)
                        print ("(STEP 10A3/33) OF AUTOMATE2REF4URI - PERFORMED FOR DIRECTION ", key2direction, " GENERATE2SHOOT4SEARCH: ", generate2shoot4uri)
                        # PERFORMED FOR DIRECTION  zero  GENERATE2SHOOT4SEARCH:  <function generate2shoot4uri at 0x0299A3D8>
                        # ...
                        # PERFORMED FOR DIRECTION  thirtythree  GENERATE2SHOOT4SEARCH:  <function generate2shoot4uri at 0x0299A3D8>
                    except:
                        print("(STEP 10ZA/33) OF AUTOMATE2REF4URI *** FAILED TO GENERATE SHOOT CODE DYNAMICALLY FOR DIRECTION ", key2direction)
    
    # -------------------------------------------------------------------------------------------------
    # GENERATE CODE FOR GUNS DYNAMICALLY
    # ------------------------------------------------------------------------------------------------- 
    print("(STEP 10B0/33) OF AUTOMATE2REF4URI - TRYING TO GENERATE CODE FOR GUNS DYNAMICALLY") 
    #         
    keys2direction = DirectionKB4Xi.keys()        
    for file2walk in DirectoryWalker(path2read4xi):
        if os.path.isdir(file2walk):
            print ("(STEP 10B1/33) OF AUTOMATE2REF4URI - DIRECTORY: " + file2walk + '\n')
            # 
        if os.path.isfile(file2walk):
            print ("(STEP 10B2/33) OF AUTOMATE2REF4URI - INPUT FILE: " + file2walk + '\n')
            # E://temp//dragonize//in//gun2dragon4uri.py
                    
            string2look = "gun2dragon4uri"
            index2look = str.find(file2walk,string2look) 
            if index2look == -1:
                pass
            else:
                print ("(STEP 10B3/33) OF AUTOMATE2REF4URI - ACCEPTED INPUT GUN FILE: " + file2walk + '\n')
                # E://temp//dragonize//in//gun2dragon4uri.py
                for key2direction in sorted(keys2direction):
                    try:        
                        generate2gun4uri(file2walk, direction2process = key2direction)
                        print ("(STEP 10B4/33) OF AUTOMATE2REF4URI - PERFORMED FOR DIRECTION ", key2direction, " GENERATE2GUN4SEARCH: ", generate2gun4uri)
                        # PERFORMED FOR DIRECTION  zero  GENERATE2GUN4SEARCH:  <function generate2gun4uri at 0x02995A08>
                        # ...
                        # PERFORMED FOR DIRECTION  thirtythree  GENERATE2GUN4SEARCH:  <function generate2gun4uri at 0x02995A08>
                    except:
                        print("(STEP 10ZB/33) OF AUTOMATE2REF4URI *** FAILED TO GENERATE GUN CODE DYNAMICALLY FOR DIRECTION ", key2direction)
                            

    #dynamic-end
    
    # -------------------------------------------------------------------------------------------------
    # 00 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'zero'
    print("(STEP 221A00/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  zero
    try: 
        from gun2zero4uri import gun2zero4uri
        print("(STEP 221B00/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2zero4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2zero4uri
            print("(STEP 221C00/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z00/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A00/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C00/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2zero4uri import shoot2zero4uri
        print("(STEP 222C00/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2zero4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z00/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi) 
    # -------------------------------------------------------------------------------------------------
    # 01 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'one'
    print("(STEP 221A01/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  one
    try: 
        from gun2one4uri import gun2one4uri
        print("(STEP 221B01/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2one4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2one4uri
            print("(STEP 221C01/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z01/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A01/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C01/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2one4uri import shoot2one4uri
        print("(STEP 222C01/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2one4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z01/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi) 
    # -------------------------------------------------------------------------------------------------
    # 02 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'two'
    print("(STEP 221A02/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  two
    try: 
        from gun2two4uri import gun2two4uri
        print("(STEP 221B02/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2two4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2two4uri
            print("(STEP 221C02/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z02/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A02/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C02/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2two4uri import shoot2two4uri
        print("(STEP 222C02/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2two4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z02/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    # -------------------------------------------------------------------------------------------------
    # 03 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'three'
    print("(STEP 221A03/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  three
    try: 
        from gun2three4uri import gun2three4uri
        print("(STEP 221B03/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2three4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2three4uri
            print("(STEP 221C03/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z03/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A03/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C03/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2three4uri import shoot2three4uri
        print("(STEP 222C03/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2three4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z03/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi) 
    # -------------------------------------------------------------------------------------------------
    # 04 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'four'
    print("(STEP 221A04/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  four
    try: 
        from gun2four4uri import gun2four4uri
        print("(STEP 221B04/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2four4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2four4uri
            print("(STEP 221C04/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z04/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A04/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C04/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2four4uri import shoot2four4uri
        print("(STEP 222C04/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2four4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z04/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi) 
    # -------------------------------------------------------------------------------------------------
    # 05 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'five'
    print("(STEP 221A05/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  five
    try: 
        from gun2five4uri import gun2five4uri
        print("(STEP 221B05/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2five4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2five4uri
            print("(STEP 221C05/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z05/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A05/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C05/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2five4uri import shoot2five4uri
        print("(STEP 222C05/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2five4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z05/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi) 
    # -------------------------------------------------------------------------------------------------
    # 06 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'six'
    print("(STEP 221A06/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  six
    try: 
        from gun2six4uri import gun2six4uri
        print("(STEP 221B06/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2six4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2six4uri
            print("(STEP 221C06/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z06/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A06/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C06/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2six4uri import shoot2six4uri
        print("(STEP 222C06/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2six4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z06/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi) 
    # -------------------------------------------------------------------------------------------------
    # 07 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'seven'
    print("(STEP 221A07/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  seven
    try: 
        from gun2seven4uri import gun2seven4uri
        print("(STEP 221B07/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2seven4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2seven4uri
            print("(STEP 221C07/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z07/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A07/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C07/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2seven4uri import shoot2seven4uri
        print("(STEP 222C07/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2seven4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z07/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi) 
    # -------------------------------------------------------------------------------------------------
    # 08 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'eight'
    print("(STEP 221A08/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  eight
    try: 
        from gun2eight4uri import gun2eight4uri
        print("(STEP 221B08/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2eight4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2eight4uri
            print("(STEP 221C08/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z08/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A08/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C08/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2eight4uri import shoot2eight4uri
        print("(STEP 222C08/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2eight4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z08/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi) 
    # -------------------------------------------------------------------------------------------------
    # 09 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'nine'
    print("(STEP 221A09/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  nine
    try: 
        from gun2nine4uri import gun2nine4uri
        print("(STEP 221B09/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2nine4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2nine4uri
            print("(STEP 221C09/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z09/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A09/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C09/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2nine4uri import shoot2nine4uri
        print("(STEP 222C09/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2nine4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z09/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi) 
    # -------------------------------------------------------------------------------------------------
    # 10 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'ten'
    print("(STEP 221A10/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  ten
    try: 
        from gun2ten4uri import gun2ten4uri
        print("(STEP 221B10/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2ten4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2ten4uri
            print("(STEP 221C10/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z10/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A10/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C10/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2ten4uri import shoot2ten4uri
        print("(STEP 222C10/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2ten4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z10/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi) 
    # -------------------------------------------------------------------------------------------------
    # 11 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'eleven'
    print("(STEP 221A11/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  eleven
    try: 
        from gun2eleven4uri import gun2eleven4uri
        print("(STEP 221B11/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2eleven4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2eleven4uri
            print("(STEP 221C11/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z11/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A11/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C11/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2eleven4uri import shoot2eleven4uri
        print("(STEP 222C11/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2eleven4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z11/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    # -------------------------------------------------------------------------------------------------
    # 12 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'twelve'
    print("(STEP 221A12/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  twelve
    try: 
        from gun2twelve4uri import gun2twelve4uri
        print("(STEP 221B12/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2twelve4uri, " FOR DIRECTION ", direction2xi)
        # 
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2twelve4uri
            print("(STEP 221C12/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z12/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A12/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C12/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2twelve4uri import shoot2twelve4uri
        print("(STEP 222C12/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2twelve4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z12/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)                                                                                                                       
    # -------------------------------------------------------------------------------------------------
    # 13 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------                         
    direction2xi = 'thirteen'
    print("(STEP 221A13/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    # TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION  thirteen
    try: 
        from gun2thirteen4uri import gun2thirteen4uri
        print("(STEP 221B13/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2thirteen4uri, " FOR DIRECTION ", direction2xi)
        # GUN FUNCTION  <function gun2thirteen4uri at 0x02D2CB28>  FOR DIRECTION  thirteen
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2thirteen4uri
            print("(STEP 221C13/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # DirectionKB4Xi TARGET FUNCTION  <function gun2thirteen4uri at 0x02D2CB28>  FOR DIRECTION  thirteen
        except:
            print("(STEP 221Z13/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A13/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C13/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2thirteen4uri import shoot2thirteen4uri
        print("(STEP 222C13/33) OF AUTOMATE2REF4URI - IMPORTED ", shoot2thirteen4uri, " FOR DIRECTION ", direction2xi)
        # 
    except:
        print("(STEP 221Z13/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi) 
    
    # -------------------------------------------------------------------------------------------------
    # 14 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'fourteen'
    print("(STEP 221A14/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2fourteen4uri import gun2fourteen4uri
        print("(STEP 221B14/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2fourteen4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2fourteen4uri
            print("(STEP 221C14/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 221Z14/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A14/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C14/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2fourteen4uri import shoot2fourteen4uri
    except:
        print("(STEP 221Z14/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)       
    # -------------------------------------------------------------------------------------------------
    # 15 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'fifteen'
    print("(STEP 221A15/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2fifteen4uri import gun2fifteen4uri
        print("(STEP 221B15/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2fifteen4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2fifteen4uri
            print("(STEP 221C15/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22115Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A15/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C15/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2fifteen4uri import shoot2fifteen4uri
    except:
        print("(STEP 22115Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 16 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'sixteen'
    print("(STEP 221A16/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2sixteen4uri import gun2sixteen4uri
        print("(STEP 221B16/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2sixteen4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2sixteen4uri
            print("(STEP 221C16/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22116Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A16/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C16/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2sixteen4uri import shoot2sixteen4uri
    except:
        print("(STEP 22116Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 17 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'seventeen'
    print("(STEP 221A17/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2seventeen4uri import gun2seventeen4uri
        print("(STEP 221B17/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2seventeen4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2seventeen4uri
            print("(STEP 221C17/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22117Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A17/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C17/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2seventeen4uri import shoot2seventeen4uri
    except:
        print("(STEP 22117Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 18 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'eighteen'
    print("(STEP 221A18/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2eighteen4uri import gun2eighteen4uri
        print("(STEP 221B18/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2eighteen4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2eighteen4uri
            print("(STEP 221C18/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22118Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A18/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C18/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2eighteen4uri import shoot2eighteen4uri
    except:
        print("(STEP 22118Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 19 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'nineteen'
    print("(STEP 221A19/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2nineteen4uri import gun2nineteen4uri
        print("(STEP 221B19/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2nineteen4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2nineteen4uri
            print("(STEP 221C19/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22119Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A19/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C19/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2nineteen4uri import shoot2nineteen4uri
    except:
        print("(STEP 22119Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 20 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'twenty'
    print("(STEP 221A20/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2twenty4uri import gun2twenty4uri
        print("(STEP 221B20/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2twenty4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2twenty4uri
            print("(STEP 221C20/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22120Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A20/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C20/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2twenty4uri import shoot2twenty4uri
    except:
        print("(STEP 22120Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 21 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'twentyone'
    print("(STEP 221A21/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2twentyone4uri import gun2twentyone4uri
        print("(STEP 221B21/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2twentyone4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2twentyone4uri
            print("(STEP 221C21/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22121Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A21/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C21/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2twentyone4uri import shoot2twentyone4uri
    except:
        print("(STEP 22121Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 22 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'twentytwo'
    print("(STEP 221A22/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2twentytwo4uri import gun2twentytwo4uri
        print("(STEP 221B22/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2twentytwo4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2twentytwo4uri
            print("(STEP 221C22/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22122Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A22/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C22/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2twentytwo4uri import shoot2twentytwo4uri
    except:
        print("(STEP 22122Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 23 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'twentythree'
    print("(STEP 221A23/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2twentythree4uri import gun2twentythree4uri
        print("(STEP 221B23/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2twentythree4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2twentythree4uri
            print("(STEP 221C23/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22123Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A23/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C23/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2twentythree4uri import shoot2twentythree4uri
    except:
        print("(STEP 22123Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 24 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'twentyfour'
    print("(STEP 221A24/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2twentyfour4uri import gun2twentyfour4uri
        print("(STEP 221B24/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2twentyfour4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2twentyfour4uri
            print("(STEP 221C24/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22124Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A24/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C24/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2twentyfour4uri import shoot2twentyfour4uri
    except:
        print("(STEP 22124Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 25 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'twentyfive'
    print("(STEP 221A25/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2twentyfive4uri import gun2twentyfive4uri
        print("(STEP 221B25/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2twentyfive4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2twentyfive4uri
            print("(STEP 221C25/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22125Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A25/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C25/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2twentyfive4uri import shoot2twentyfive4uri
    except:
        print("(STEP 22125Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 26 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'twentysix'
    print("(STEP 221A26/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2twentysix4uri import gun2twentysix4uri
        print("(STEP 221B26/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2twentysix4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2twentysix4uri
            print("(STEP 221C26/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22126Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A26/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C26/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2twentysix4uri import shoot2twentysix4uri
    except:
        print("(STEP 22126Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 27 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'twentyseven'
    print("(STEP 221A27/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2twentyseven4uri import gun2twentyseven4uri
        print("(STEP 221B27/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2twentyseven4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2twentyseven4uri
            print("(STEP 221C27/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22127Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A27/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C27/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2twentyseven4uri import shoot2twentyseven4uri
    except:
        print("(STEP 22127Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 28 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'twentyeight'
    print("(STEP 221A28/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2twentyeight4uri import gun2twentyeight4uri
        print("(STEP 221B28/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2twentyeight4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2twentyeight4uri
            print("(STEP 221C28/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22128Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A28/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C28/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2twentyeight4uri import shoot2twentyeight4uri
    except:
        print("(STEP 22128Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 29 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'twentynine'
    print("(STEP 221A29/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2twentynine4uri import gun2twentynine4uri
        print("(STEP 221B29/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2twentynine4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2twentynine4uri
            print("(STEP 221C29/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22129Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A29/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C29/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2twentynine4uri import shoot2twentynine4uri
    except:
        print("(STEP 22129Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 30 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'thirty'
    print("(STEP 221A30/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2thirty4uri import gun2thirty4uri
        print("(STEP 221B30/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2thirty4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2thirty4uri
            print("(STEP 221C30/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22130Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A30/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C30/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2thirty4uri import shoot2thirty4uri
    except:
        print("(STEP 22130Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 31 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'thirtyone'
    print("(STEP 221A31/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2thirtyone4uri import gun2thirtyone4uri
        print("(STEP 221B31/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2thirtyone4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2thirtyone4uri
            print("(STEP 221C31/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22131Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A31/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C31/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2thirtyone4uri import shoot2thirtyone4uri
    except:
        print("(STEP 22131Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 32 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'thirtytwo'
    print("(STEP 221A32/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2thirtytwo4uri import gun2thirtytwo4uri
        print("(STEP 221B32/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2thirtytwo4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2thirtytwo4uri
            print("(STEP 221C32/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # 
        except:
            print("(STEP 22132Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A32/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C32/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2thirtytwo4uri import shoot2thirtytwo4uri
    except:
        print("(STEP 22132Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)  
    # -------------------------------------------------------------------------------------------------
    # 33 IMPORT AND INTEGRATE 
    # -------------------------------------------------------------------------------------------------     
    direction2xi = 'thirtythree'
    print("(STEP 221A33/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from gun2thirtythree4uri import gun2thirtythree4uri
        print("(STEP 221B33/33) OF AUTOMATE2REF4URI - TRYING TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION ", gun2thirtythree4uri, " FOR DIRECTION ", direction2xi)
        try:
            DirectionKB4Xi[direction2xi] ['function2target']  = gun2thirtythree4uri
            print("(STEP 221C33/33) OF AUTOMATE2REF4URI - DirectionKB4Xi TARGET FUNCTION ", DirectionKB4Xi[direction2xi] ['function2target'], " FOR DIRECTION ", direction2xi)
            # DirectionKB4Xi TARGET FUNCTION  <function gun2thirtythree4uri at 0x0000000003DF02F0>  FOR DIRECTION  thirtythree
        except:
            print("(STEP 22133Z/33) OF AUTOMATE2REF4URI *** FAILED TO INTEGRATE DYNAMICALLY GENERATED GUN FUNCTION FOR DIRECTION ", direction2xi)         
    except:
        print("(STEP 221A33/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED FUNCTIONS FROM THEIR MODULES FOR DIRECTION ", direction2xi)
        # 
    print("(STEP 221C33/33) OF AUTOMATE2REF4URI - TRYING TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)
    try: 
        from shoot2thirtythree4uri import shoot2thirtythree4uri
    except:
        print("(STEP 22133Z/33) OF AUTOMATE2REF4URI *** FAILED TO IMPORT DYNAMICALLY GENERATED SHOOT FUNCTION FOR DIRECTION ", direction2xi)                                                                                                                                                  
                                                            
    #dynamic-start
    print ("(STEP 300/33) OF AUTOMATE2REF4URI - TRYING PROCESSES DYNAMICALLY ") 
    keys2direction = DirectionKB4Xi.keys()
    for key2direction in sorted(keys2direction):
        try:
            queue4xi           =  DirectionKB4Xi[key2direction] ['queue']
            channel2consume4xi =  DirectionKB4Xi[key2direction] ['channel2consume']
            channel2publish4xi =  DirectionKB4Xi[key2direction] ['channel2publish']
            path4xi            =  DirectionKB4Xi[key2direction] ['path2analyse'] 
            gun4xi             =  DirectionKB4Xi[key2direction] ['function2target']
        except:
            print ("(STEP 310Z/33) OF AUTOMATE2REF4URI *** FAILED In SETTING VALUES")
        
        try:
            # ------------------------------------------------------------------------------ 
            # GUN DYNAMICALLY WITH MULTIPROCESSING4XI
            # ------------------------------------------------------------------------------     
    
            print ("(STEP 310A1/33) OF AUTOMATE2REF4URI - PASSING QUEUE4XI ", queue4xi, " FOR DIRECTION ", key2direction)
            # ...
            # QUEUE4XI  <queue4xi.Queue4Xi object at 0x02DD7E50>  FOR DIRECTION  seventeen
            # ...
            # QUEUE4XI  <queue4xi.Queue4Xi object at 0x02E06FF0>  FOR DIRECTION  thirtythree

             
            print ("(STEP 310A2/33) OF AUTOMATE2REF4URI - PASSING CHANNEL2CONSUME4XI ", channel2consume4xi, " FOR DIRECTION ", key2direction)
            # ...
            # CHANNEL2CONSUME4XI  <pipeconnection4xi.PipeConnection4Xi object at 0x02DD7150>  FOR DIRECTION  thirtythree
            # 
            
            print ("(STEP 310A3/33) OF AUTOMATE2REF4URI - PASSING CHANNEL2PUBLISH4XI ", channel2publish4xi, " FOR DIRECTION ", key2direction)
            # ...
            # CHANNEL2PUBLISH4XI  <pipeconnection4xi.PipeConnection4Xi object at 0x02DD7250>  FOR DIRECTION  thirtythree
            #
            print ("(STEP 310A4/33) OF AUTOMATE2REF4URI - PASSING PATH4XI ", path4xi, " FOR DIRECTION ", key2direction)
            # ...
            # PATH4XI  M://temp//yophotos//test2thirtythree//  FOR DIRECTION  thirtythree
            
            print ("(STEP 310A5/33) OF AUTOMATE2REF4URI - USING TARGET FUNCTION GUN4XI ", gun4xi, " FOR DIRECTION ", key2direction)
            # ...
            # TARGET FUNCTION GUN4XI  <function gun2thirtythree4uri at 0x08013C90>  FOR DIRECTION  thirtythree

        except:
            print ("(STEP 310Z1/33) OF AUTOMATE2REF4URI *** FAILED WITH PARAMETERS FOR DIRECTION ", key2direction)
                     
        try:         
            # -----------------------------------------------------------------------------------------    
            # PROCESS DYNAMICALLY WITH TARGET FUNCTION CREATED
            # -----------------------------------------------------------------------------------------                     
            process4xi = Process4Xi(target=gun4xi, args=(queue4xi, channel2consume4xi, channel2publish4xi, path4xi))
            print("(STEP 310A7/33) OF AUTOMATE2REF4URI - CREATED PROCESS OBJECT: ", process4xi, " FOR DIRECTION ", key2direction)                     
            # 
        except:
            print ("(STEP 310Z2/33) OF AUTOMATE2REF4URI *** FAILED TO CREATE PROCESS WITH TARGET FUNCTION FOR DIRECTION ", key2direction)
        
                                
        try:        
            # -----------------------------------------------------------------------------------------    
            # PROCESS NAME DYNAMICALLY 
            # -----------------------------------------------------------------------------------------                        
            name2process4xi = process4xi.name
            print("(STEP 310A8/33) OF AUTOMATE2REF4URI - CREATED PROCESS NAME: ", name2process4xi, " FOR DIRECTION ", key2direction) 
            # ...
            # Process4Xi-24  FOR DIRECTION  thirtythree
        except:
            print ("(STEP 310Z3/33) OF AUTOMATE2REF4URI *** FAILED TO GET NAME OF PROCESS FOR DIRECTION ", key2direction)
                
        try:         
            # -----------------------------------------------------------------------------------------    
            # PROCESS START DYNAMICALLY 
            # ----------------------------------------------------------------------------------------- 
            process4xi.start()
            print("(STEP 310A9/33) OF AUTOMATE2REF4URI - STARTED PROCESS NAME: ", name2process4xi, " FOR DIRECTION ", key2direction)
            # ...
            # Process4Xi-24  FOR DIRECTION  thirtythree

        except:
            print ("(STEP 310Z4/33) OF AUTOMATE2REF4URI *** FAILED TO START PROCESS FOR DIRECTION ", key2direction)
            
        try:        
            # -----------------------------------------------------------------------------------------    
            # PROCESS ALIVE CHECK DYNAMICALLY 
            # -----------------------------------------------------------------------------------------                   
            status2process4xi = process4xi.is_alive()
            print("(STEP 310A10/33) OF AUTOMATE2REF4URI - PROCESS STATUS: ", status2process4xi, " FOR DIRECTION ", key2direction)
            # ...
            # True  FOR DIRECTION  thirtythree
        except:
            print ("(STEP 310Z5/33) OF AUTOMATE2REF4URI *** FAILED TO CHECK IF PROCESS IS ALIVE FOR DIRECTION ", key2direction)
            
                    
        try:            
            # -----------------------------------------------------------------------------------------    
            # PROCESS RUN DYNAMICALLY 
            # -----------------------------------------------------------------------------------------
            process4xi.run()
            print("(STEP 310A11/33) OF AUTOMATE2REF4URI - PERFORMED RUN COMMAND TO PROCESS NAME: ", name2process4xi, " FOR DIRECTION ", key2direction)
            # ...
            # PERFORMED RUN COMMAND TO PROCESS NAME:  Process4Xi-24  FOR DIRECTION  thirtythree
            
            ack4run = True 
        except:
            print ("(STEP 310Z6/33) OF AUTOMATE2REF4URI *** FAILED TO RUN PROCESS FOR DIRECTION ", key2direction) 
        try:
            # --------------------------------------------------------------------------------
            # PROCESS - GETTING COMMUNICATION AND CONTROL MESSAGES FROM QUEUES  DYNAMICALLY                         
            # --------------------------------------------------------------------------------   
            print ("(STEP 310A12/33) OF AUTOMATE2REF4URI - GETTING COMMUNICATION AND CONTROL MESSAGES FROM QUEUES FOR DIRECTION ", key2direction)
            # 
            message2get4xi = queue4xi.get()
            print("(STEP 310A14/33) OF AUTOMATE2REF4URI - GOT FROM QUEUE: ", queue4xi, " MESSAGE: ", message2get4xi, " FOR DIRECTION ", key2direction)
            # ...
            # GOT FROM QUEUE:  <queue4xi.Queue4Xi object at 0x02E06FF0>  MESSAGE:  <roger4xi>roger2thirtythree</roger4xi>  FOR DIRECTION  thirtythree

        except:
            print ("(STEP 310Z7/33) OF AUTOMATE2REF4URI *** FAILED GETTING COMMUNICATION AND CONTROL MESSAGES FROM QUEUES FOR DIRECTION ", key2direction)    
                        
        try:
            # --------------------------------------------------------------------------------
            # PROCESS - RECEIVING COMMUNICATION AND CONTROL MESSAGES FROM PIPES DYNAMICALLY                           
            # --------------------------------------------------------------------------------       
            print("(STEP 310A15/33) OF AUTOMATE2REF4URI - RECEIVING COMMUNICATION AND CONTROL MESSAGES FROM PIPES FOR DIRECTION ", key2direction)  
            # 
            message2receive4xi = channel2consume4xi.recv()
            print("(STEP 310A16/33) OF AUTOMATE2REF4URI - RECEIVED FROM CONSUMER CHANNEL: ", channel2consume4xi, " MESSAGE: ", message2receive4xi, " FOR DIRECTION ", key2direction)
            # ...
            # RECEIVED FROM CONSUMER CHANNEL:  <pipeconnection4xi.PipeConnection4Xi object at 0x02DD7150>  MESSAGE:  <roger4xi>roger2thirtythree</roger4xi>  FOR DIRECTION  thirtythree

        except:
            print ("(STEP 310Z8/33) OF AUTOMATE2REF4URI *** FAILED GETTING COMMUNICATION AND CONTROL MESSAGES FROM PIPES FOR DIRECTION ", key2direction)            


    #dynamic-end    
                


    # =============================================================================================   
    # (Step 33/33)
    # =============================================================================================    
         
    print('=' *75)
    print("(Step 33A/33) OF AUTOMATE2REF4URI FOR ", master2ref4uri, " COMPLETED  ", time4xi())
    # 
    
    ack2trace = False
    if ack2trace is True:
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print ('(STEP 33B/33) OF AUTOMATE2REF4URI - PRINTING TRACE WITH T2XI', t2xi) 
        # <print4xi.Print4Xi object at 0x029C5570>
        
        print_trace4xi(t2xi)        
        print ('(STEP 33C/33) OF AUTOMATE2REF4URI - PRINTED TRACE WITH T2XI', t2xi)           
        # <print4xi.Print4Xi object at 0x029C5570>

#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# ROOT4XI\Studio4Xi\Python\3.3\txt\automate2ref4uri.txt
# \web\xml\ace-automate2ref4uri.xml
# \web\xml\reason-automate2ref4uri.xml
# \web\xml\sense-automate2ref4uri.xml
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of automate2ref4uri.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

